	// Trigger Save on Enter keypress
	jQuery('#cdp-content-wrapper').on( 'keypress', '.cdp-input', function(e) {
		if(e.which == 13) {
			jQuery(e.target).blur();
		}
	});

	// Controls tabs
	jQuery('.tab-button').click(function() {
		button_id = jQuery(this).attr('id');
		tag = jQuery(this).attr('tag');
		if( tag ){
			jQuery('.view-wrapper.active').removeClass('active');
			jQuery('#'+jQuery('#'+tag).text()+'-view-wrapper').addClass('active');
		}
		jQuery(this).siblings('.active').removeClass('active');
		jQuery(this).addClass('active');
		jQuery(this).parent().parent().find('.tab-content.active').removeClass('active');
		jQuery('.'+button_id).addClass('active');
	});
	// Controls inner tabs
	jQuery('.inner-tab-button').click(function() {
		button_id = jQuery(this).attr('id');
		jQuery(this).siblings('.active').removeClass('active');
		jQuery(this).addClass('active');
		jQuery(this).parents('#content-loan').find('.tab-inner-content.active').removeClass('active');
		jQuery('.'+button_id).addClass('active');
	});

	// Input Triggers
	jQuery('#cdp-content-wrapper').on( 'input', '.cdp-input', function(e) {
		jQuery(e.target).addClass('value-updated');
		jQuery('#cdp-content-wrapper').addClass('not-saved');
	})
	jQuery('#cdp-content-wrapper').on( 'input', '.cdp-input-data', function(e) {
		jQuery(e.target).addClass('value-updated');
		jQuery('#cdp-content-wrapper').addClass('not-saved');
	})
	jQuery('#cdp-content-wrapper').on( 'change', '.cdp-input', function(e) {
		jQuery(e.target).addClass('value-updated');
		if( jQuery(e.target).attr('type') == 'checkbox' && !jQuery(e.target).is(':checked') ){
			jQuery(e.target).val('').focus(); //focus needed**
		} else if ( jQuery(e.target).attr('type') == 'checkbox' && jQuery(e.target).is(':checked') ){
			jQuery(e.target).val('on').focus(); //focus needed**
		}
		jQuery('#cdp-content-wrapper').addClass('not-saved');
	})

	// Input change
	jQuery('#cdp-content-wrapper').on( 'focusout', '.cdp-input', function(e) {
		if( jQuery(e.target).hasClass('value-updated') ){
			jQuery(e.target).removeClass('value-updated');
			tag = jQuery(e.target).attr('tag');
			extra = jQuery(e.target).attr('extra');
			if( jQuery(this).hasClass('text-inject') ){
				data = {'path': jQuery(e.target).attr('name'), 'value': encodeURIComponent(jQuery(e.target).val()) };
			} else {
				data = {'path': jQuery(e.target).attr('name'), 'value': jQuery(e.target).val()};
			}

			cdp_ajax_call( 'saveAdminSettings', data, '#cdp-content-wrapper' ).done(function(result) {
				if( tag ){
					jQuery('#view-'+tag).remove();
					jQuery('#ajax-'+tag).addClass('loading');
					data = {'id': 'content-'+tag};
					cdp_ajax_call( 'get'+tag, data, '#cdp-content-wrapper' ).done(function(result) {
						jQuery('#ajax-'+tag).removeClass('loading');
					}).fail(function() {
					    alert('Data Not Saved');
					});
				}

				if( extra ){
					location.reload();
				}
			}).fail(function() {
			    alert('Data Not Saved');
			});
		}
	})
	//Switch Tabs
	jQuery('#cdp-import-advanced').click(function(e){
		jQuery('#cdp-content-wrapper-advanced').removeClass('hide').addClass('display');
		jQuery('#cdp-content-wrapper-default').removeClass('display').addClass('hide');
	})
	jQuery('#cdp-default-settings').click(function(e){
		jQuery('#cdp-content-wrapper-default').removeClass('hide').addClass('display');
		jQuery('#cdp-content-wrapper-advanced').removeClass('display').addClass('hide');
	})

	//Delete Custom Import
	jQuery('.import-delete-custom').click(function(e){
		customID = jQuery(e.target).attr('value');
		dealerID = jQuery(e.target).attr('dealer');
		data = {'data_id':customID,'dealer':dealerID}

		//Ajax Call
		cdp_ajax_call( 'delete_Custom_Import', data, '#cdp-content-wrapper' ).done(function(result) {
			jQuery('#import-dealer-'+dealerID).remove();
			//Refresh Imports
			cdp_ajax_call( 'refresh_Imports', data, '#cdp-content-wrapper' ).done(function(result) {
				jQuery('#current-import-dealer-wrapper').append(result['content']);
			}).fail(function() {

			});
		}).fail(function() {

		});
	})
	//Update Custom Import
	jQuery('.import-update-custom').click(function(e){
		importID = jQuery(e.target).attr('value');
		dealerID = jQuery(e.target).attr('dealer');
		parentID = jQuery('#import-custom-content-'+importID);
		//Populate
		jQuery('#default-add-title').addClass('hide');
		jQuery('#import-update-id').attr('value',importID).addClass('display').html('<h3 class="center-title">Updating Custom Import</h3>');
		jQuery('#import-dealer-select').val(dealerID);
		jQuery('#import-saleclass-select').val(parentID.find('.import-saleclass-glance').attr('value'));
		jQuery('#import-make-input').val(parentID.find('.import-make-glance-value').attr('value'));
		jQuery('#import-make-symbol').val(parentID.find('.import-make-glance-symbol').attr('value'));
		jQuery('#import-year-input').val(parentID.find('.import-year-glance-value').attr('value'));
		jQuery('#import-year-symbol').val(parentID.find('.import-year-glance-symbol').attr('value'));
		jQuery('#add-custom-import').text('Update Custom Import');

	});
	//Add Custom Import
	jQuery('#add-custom-import').click(function(){
		import_error = false;
		jQuery('#import-ajax-message').removeClass('error');
		// Make sure a dealer is selected
		if( jQuery('#import-dealer-select').val() === '0' ){
			jQuery('#import-ajax-message').text('A dealer must be selected in order to create a custom import.');
			jQuery('#import-ajax-message').addClass('error');
			import_error = true;
		}
		// Check the year
		if( !import_year_check() && !import_error){
			jQuery('#import-ajax-message').text('Only one year may be entered or change to Equal (=).');
			jQuery('#import-ajax-message').addClass('error');
			import_error = true;
		}
		if( !import_error ){
			//Build save data
			update_id = jQuery('#import-update-id').attr('value');
			dealer_id = jQuery('#import-dealer-select').val();
			saleclass = jQuery('#import-saleclass-select').val();
			make_array = {'value': jQuery('#import-make-input').val(), 'symbol': jQuery('#import-make-symbol').val() };
			year_array = {'value': jQuery('#import-year-input').val(), 'symbol': jQuery('#import-year-symbol').val() };
			data = {'key':'import','update':update_id,'dealer':dealer_id,'value': {'saleclass':saleclass,'make':make_array,'year':year_array} }

			//Ajax Call
			cdp_ajax_call( 'saveCDP_Data', data, '#cdp-content-wrapper' ).done(function(result) {
				jQuery('#'+data['key']+'-ajax-message').addClass('found').text('Custom Import Added to dealer.');
				//Refresh Imports
				cdp_ajax_call( 'refresh_Imports', data, '#cdp-content-wrapper' ).done(function(result) {
					jQuery('#import-dealer-'+data['dealer']).remove();
					jQuery('#current-import-dealer-wrapper').append(result['content']);
				}).fail(function() {

				});
				//console.dir(data);
			}).fail(function() {
				jQuery('#'+data['key']+'-ajax-message').addClass('error').text('Ajax Failed. Data not saved. Try again.');
			    //console.dir(result);
			});
			jQuery('#add-custom-import').text('Add Custom Import');
			jQuery('#default-add-title').removeClass('hide');
			jQuery('#import-update-id').removeClass('display');
		}
	})

	function import_year_check(){
		if( jQuery('#import-year-input').val() === '' ){
			return true;
		}
		if( jQuery('#import-year-symbol').val() === '0' ){
			return true;
		}
		if( jQuery('#import-year-symbol').val() === '2' ||  jQuery('#import-year-symbol').val() === '3' ){
			year_array = jQuery('#import-year-input').val().split(',');
			if( year_array.length === 1 ){
				return true;
			} else {
				return false;
			}
		}
	}

	// Update Adding New Dealer Buttons with Ajax check | Advanced Settings
	jQuery('#add-dealer-button-advanced').click(function(){
		dealer = jQuery('#add-additonal-dealer-row #company-id-advanced').val();
		if( jQuery.isNumeric(dealer) ){
			data = {'key': 'dealer_check', 'value': dealer};
			jQuery('#dealer-ajax-message-advanced').removeClass('error').text('');
			cdp_ajax_call( 'manual_dealer_check', data, '#cdp-content-wrapper' ).done(function(result) {
				if( data['key'] == 'dealer_check' && result['key'] != 'error' ){
					jQuery('#cdp-new-value').val(jQuery('#add-additonal-dealer-row #company-id-advanced').val());
					jQuery('#cdp-form-post-action').val('dealerAdd');
					jQuery('#cdp-admin-form-post').submit();
				}
				jQuery('#dealer-ajax-message-advanced').addClass(result['key']).text(result['content']);

			}).fail(function() {
				jQuery('#dealer-ajax-message-advanced').addClass('error').text('Ajax Failed. Try again.');
			});
		} else {
			jQuery('#dealer-ajax-message-advanced').addClass('error').text('Not a valid Dealer Value');
		}

	});

	// New data update
	jQuery('#cdp-content-wrapper').on( 'focusout', '.cdp-input-data', function(e) {
		if( jQuery(e.target).hasClass('value-updated') ){
			//Clean Up
			jQuery(e.target).removeClass('value-updated');
			jQuery('.data-ajax-message.error').removeClass('error');
			jQuery('.data-ajax-message.found').removeClass('found');
			//Check Value Type
			if( jQuery(this).hasClass('text-inject') ){
				data = {'key': jQuery(e.target).attr('name'), 'value': encodeURIComponent(jQuery(e.target).val()) };
			} else {
				data = {'key': jQuery(e.target).attr('name'), 'value': jQuery(e.target).val()};
			}
			//Ajax Call
			cdp_ajax_call( 'saveCDP_Data', data, '#cdp-content-wrapper' ).done(function(result) {
				if( data['key'] == 'dealer' && result['key'] != 'error' ){
					new_dealer = '<option value="'+data['value']+'">'+data['value']+'</option>';
					jQuery('#import-dealer-select').append(new_dealer);
				}
				jQuery('#'+data['key']+'-ajax-message').addClass(result['key']).text(result['content']);
				//console.dir(data);
			}).fail(function() {
				jQuery('#'+data['key']+'-ajax-message').addClass('error').text('Ajax Failed. Data not saved. Try again.');
			    //console.dir(result);
			});
		}
	})

	jQuery('ul.admin-multi-select').on( 'click', 'span.admin-select-checkbox', function(e){
		if( jQuery(e.target).parent().hasClass('selected') ){
			jQuery(e.target).text('').parent().removeClass('selected');
		} else {
			jQuery(e.target).text('X').parent().addClass('selected');
		}
		jQuery('#cdp-content-wrapper').addClass('not-saved');
	});

	//**Sort Code
	jQuery('.init-admin-db').change(function(e){
		filters = {};
		jQuery('.admin-db-filter').each( function(){
			if( jQuery(this).val() != '' ){
				filters[jQuery(this).attr('tag')] = jQuery(this).val();
			}
		})
		data = {'filters' : filters}
		cdp_ajax_call( 'dbGetCount', data, '' ).done(function(result) {
			jQuery('.current-sort-count-value span').text(result['content']);
			//console.dir(result);
		}).fail(function() {
		    //alert('Data Note Saved...');
		});
	})

	jQuery('.init-ajax-save-sort').click(function(e){
		values = data = {}; error = '';
		path = jQuery(e.target).attr('name');
		parentWrapper = jQuery(e.target).parents('.inner-td-content-full');

		jQuery(parentWrapper).find('.admin-db-sort-value').each(function(){
			if( jQuery(this).hasClass('required') ){
				if( jQuery(this).val() == 0 || jQuery(this).val() == ''){
					error += jQuery(this).attr('tag')+ ' field requires a value.' +"\n";
				} else {
					values[jQuery(this).attr('tag')] = jQuery(this).val();
				}
			} else if( jQuery(this).val() != '' ) {
				values[jQuery(this).attr('tag')] = jQuery(this).val();
			}
		})
		if( error ){
			//console.log(error);
			//alert(error);
		} else {
			data = { 'path': path, 'value': values };
			cdp_ajax_call( 'saveAdminSettings', data, '#cdp-content-wrapper' ).done(function(result) {
				cdp_ajax_call( 'applySortUpdates', '', '' ).done(function(result) {
					//console.dir(result);
					jQuery('#sortRows').find('.inner-row-wrapper').remove();
					jQuery('#sortRows').append(result['content']);
				}).fail(function() {
				    alert('Data Not Applied...');
				});
			}).fail(function() {
			    alert('Data Not Saved...');
			});
		}

	})

	//** Banner Save
	jQuery('.init-ajax-save-banner').click(function(e){
		values = data = {}; error = '';
		path = jQuery(e.target).attr('name');
		parentWrapper = jQuery(e.target).parents('.inner-td-content-full');

		jQuery(parentWrapper).find('.admin-db-banner-value').each(function(){
			if( jQuery(this).hasClass('required') ){
				if( jQuery(this).val() == 0 || jQuery(this).val() == ''){
					error += jQuery(this).attr('tag')+ ' field requires a value.' +"\n";
				} else {
					values[jQuery(this).attr('tag')] = jQuery(this).val();
				}
			} else if( jQuery(this).hasClass('text-inject') ){
				values[jQuery(this).attr('tag')] = encodeURIComponent( jQuery(this).val() );
			} else {
				values[jQuery(this).attr('tag')] = jQuery(this).val();
			}
		})
		if( error ){
			//console.log(error);
			//alert(error);
		} else {
			data = { 'path': path, 'value': values };
			cdp_ajax_call( 'saveAdminSettings', data, '#cdp-content-wrapper' ).done(function(result) {
				cdp_ajax_call( 'getBannerValues', '', '' ).done(function(result) {
					console.dir(result);
					jQuery('#bannerRows').find('.inner-row-wrapper').remove();
					jQuery('#bannerRows').append(result['content']);
				}).fail(function() {
				    alert('Data Not Applied...');
				});
			}).fail(function() {
			   // alert('Data Not Saved...');
			});
		}

	})

	//
	jQuery('div.init-ajax-save').click(function(e){
		initID = jQuery(e.target).attr('tag');
		path = jQuery(e.target).attr('name');
		parentID = jQuery('#admin-multi-select-'+initID);
		selected = marked = '';
		jQuery(parentID).children('.selected').each( function(){
			marked += jQuery(this).attr('name')+' ';
		})
		selected = jQuery.trim(marked).replace(/ /g, ',');
		data = {'path': path, 'value': selected };
		cdp_ajax_call( 'saveAdminSettings', data, '#cdp-content-wrapper' ).done(function(result) {

		}).fail(function() {
		    alert('Data Note Saved...');
		});
	});

	//Allow API URL to be changed
   jQuery('#api-show').click(function(e){
     jQuery('#api-hidden').slideDown();
   })

	// Flush
	jQuery('#run-flush').click(function(e){
		data = {};
		cdp_ajax_call( 'runFlush', data, '#cdp-content-wrapper' ).done(function(result) {
			location.reload();
		}).fail(function() {

			jQuery(e.target).text('Failed: Try Again?');
		});
	})


	jQuery('#cdp-change-company-buttons > div').click(function(e){
		previous_id = jQuery('#cdp-previous-id').val();
		new_id = jQuery('input#company-id').val();
		if(new_id != 0 && previous_id != new_id){
			if( jQuery(e.target).attr('id') == 'change-only-company'){
				jQuery('#cdp-form-post-action').val('dealerChange');
				jQuery('#cdp-new-value').val(new_id);
				jQuery('#cdp-path-value').val(jQuery(e.target).attr('name'));
				jQuery('#cdp-admin-form-post').submit();
			} else if ( jQuery(e.target).attr('id') == 'change-clear-company') {
				jQuery('#cdp-form-post-action').val('dealerChangeClear');
				jQuery('#cdp-new-value').val(new_id);
				jQuery('#cdp-path-value').val(jQuery(e.target).attr('name'));
				jQuery('#cdp-admin-form-post').submit();
			}

		}
	})

	/**
	Delete manually added Dealer --- 01/08/2019
	**/
	jQuery('.import-remove-dealer-button').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		jQuery('#cdp-form-post-action').val('dealerDelete');
		jQuery('#cdp-new-value').val(jQuery(e.target).attr('value'));
		jQuery('#cdp-admin-form-post').submit();
		/*
		dealer = jQuery(e.target).val();
		data = {'dealer':dealer}
		//Ajax Call
		cdp_ajax_call( 'delete_Dealer', data, '#cdp-content-wrapper' ).done(function(result) {
			jQuery('#import-dealer-'+dealer).remove();
		}).fail(function() {
		});
		*/
	})
	/**
	Delete manually added Dealer END
	**/

	/**
	Admin manual inventory update --- 01/08/2019
	**/
	jQuery('.cdp-run-input').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		if( jQuery(e.target).attr('id') == 'manually-run-import-job' ){
			jQuery('#manually-run-import-job-confirm').slideDown();
		} else if( jQuery(e.target).attr('id') == 'manually-run-company-job' ) {
			jQuery('#cdp-form-post-action').val('dealerRefresh');
			jQuery('#cdp-admin-form-post').submit();
		} else {
			jQuery('#cdp-form-post-action').val('dealerImport');
			jQuery('#cdp-form-post-data').val( jQuery(e.target).attr('dealer') );
			jQuery('#cdp-admin-form-post').submit();
		}
	});
	jQuery('#confirm-full-manual-run').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		jQuery('#cdp-form-post-action').val('fullImport');
		jQuery('#cdp-form-post-data').val('00');
		jQuery('#cdp-admin-form-post').submit();
	})
	jQuery('#decline-full-manual-run').click(function(e){
		jQuery('#manually-run-import-job-confirm').slideUp();
	});
	/**
	Admin manual inventory END
	**/

	/**
	Special Posts to Admin --- 01/08/2019
	**/
	jQuery('#admin-clear-transient').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		jQuery('#cdp-form-post-action').val('clearTransient');
		jQuery('#cdp-admin-form-post').submit();
	});
	jQuery('#admin-truncate-inventory').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		jQuery('#cdp-form-post-action').val('resetInventory');
		jQuery('#cdp-admin-form-post').submit();
	});
	jQuery('#create-cron-button').click(function(e){
		jQuery('#no-cron-status-header').addClass('running');
		jQuery('#cdp-form-post-action').val('addCDPCronJob');
		jQuery('#cdp-admin-form-post').submit();
	});
	jQuery('#admin-delete-cron').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		jQuery('#cdp-form-post-action').val('deleteCDPCronJob');
		jQuery('#cdp-admin-form-post').submit();
	});
	jQuery('#cdp-style-save').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		jQuery('#cdp-form-post-action').val('cdpOptionUpdate');
		jQuery('#cdp-new-value').val(encodeURIComponent(jQuery('textarea#style-inject').val()));
		jQuery('#cdp-path-value').val(jQuery('textarea#style-inject').attr('name'));
		jQuery('#cdp-admin-form-post').submit();
	});
	jQuery('#cdp-detail-script-save').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		jQuery('#cdp-form-post-action').val('cdpOptionUpdate');
		jQuery('#cdp-new-value').val(encodeURIComponent(jQuery('textarea#detail-script').val()));
		jQuery('#cdp-path-value').val(jQuery('textarea#detail-script').attr('name'));
		jQuery('#cdp-admin-form-post').submit();
	});
	jQuery('#cdp-list-script-save').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		jQuery('#cdp-form-post-action').val('cdpOptionUpdate');
		jQuery('#cdp-new-value').val(encodeURIComponent(jQuery('textarea#list-script').val()));
		jQuery('#cdp-path-value').val(jQuery('textarea#list-script').attr('name'));
		jQuery('#cdp-admin-form-post').submit();
	});
	jQuery('#cdp-list-ajax-script-save').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		jQuery('#cdp-form-post-action').val('cdpOptionUpdate');
		jQuery('#cdp-new-value').val(encodeURIComponent(jQuery('textarea#list-ajax-script').val()));
		jQuery('#cdp-path-value').val(jQuery('textarea#list-ajax-script').attr('name'));
		jQuery('#cdp-admin-form-post').submit();
	});
	jQuery('#cdp-disclaimer-save').click(function(e){
		jQuery('#cdp-content-wrapper').addClass('running');
		jQuery('#cdp-form-post-action').val('cdpOptionUpdate');
		jQuery('#cdp-new-value').val(encodeURIComponent(jQuery('textarea#cdp-disclaimer').val()));
		jQuery('#cdp-key-value').val(jQuery('textarea#cdp-disclaimer').attr('name'));
		jQuery('#cdp-admin-form-post').submit();
	});
	/**
	Special Posts to Admin END
	**/


	// AddTable Row
	jQuery('.add-row-button').click(function(){
		key = jQuery(this).attr('tag');
		tag = 'addTableRow';
		data = {'id': key};
		jQuery('#'+key).children().remove();
		jQuery('#'+key).siblings('.ajax-loading-message').addClass('loading');
		cdp_ajax_call( tag, data, '' ).done(function(result) {
			jQuery('#'+key).siblings('.ajax-loading-message').removeClass('loading');
		}).fail(function() {
		    alert('Data Not Added');
		});
	});

	// RemoveTable Row
	jQuery('.inner-table-content').on( 'click', 'div.remove', function(e){
		key = jQuery(e.target).parent().parent().parent().attr('ID');
		tag = 'removeTableRow';
		value = jQuery(e.target).attr('tag');
		data = {'id': key, 'value': value};
		jQuery('#'+key).children().remove();
		jQuery('#'+key).siblings('.ajax-loading-message').addClass('loading');
		cdp_ajax_call( tag, data, '' ).done(function(result) {
			jQuery('#'+key).siblings('.ajax-loading-message').removeClass('loading');
		}).fail(function() {
		    alert('Data Not Removed');
		});
	});

	jQuery('.inner-table-content').on( 'click', 'div.remove-single', function(e){
		key = jQuery(e.target).parents('.inner-table-content').attr('ID');
		jQuery(e.target).parents('.inner-row-wrapper').remove();
		tag = 'removeTableRow';
		value = jQuery(e.target).attr('tag');
		data = {'id': key, 'value': value};
		cdp_ajax_call( tag, data, '' ).done(function(result) {

		}).fail(function() {
		    alert('Data Not Removed');
		});
	});

	// Generate Keyword Pot
	jQuery('.generate-keyword-pot').click(function(){
		key = jQuery(this).attr('tag');
		tag = 'generateKeywordPot';
		data = {'id': key};
		jQuery('#'+key).text('');
		jQuery('#'+key).siblings('.ajax-loading-message').addClass('loading');
		cdp_ajax_call( tag, data, '' ).done(function(result) {
			jQuery('#'+key).siblings('.ajax-loading-message').removeClass('loading');
		}).fail(function() {
		    alert('Data Not Added');
		});
	});

	// Show Inner Table Row Content
	jQuery('.inner-table-content').on( 'click', '.inner-row-label', function(e){
		if( jQuery(e.target).parent().siblings('.inner-row-content').hasClass('active') ){
			jQuery(e.target).parent().siblings('.inner-row-content').removeClass('active');
		} else {
			jQuery(e.target).parent().siblings('.inner-row-content').addClass('active');
		}
	});

	// Call Media Upload | tags
	jQuery('.inner-table-content').on( 'click', '.custom_media_upload', function (e)  {
    	e.preventDefault();
		media_id = e.target.id;

    	var custom_uploader = wp.media({
    	    title: 'Upload Icon',
			width: 200,
			height: 200,
    	    button: {
    	        text: 'Apply Icon'
    	    },
    	    multiple: false  // Set this to true to allow multiple files to be selected
    	})
    	.on('select', function() {
    	    var attachment = custom_uploader.state().get('selection').first().toJSON();
    	    jQuery('.custom_media_image.'+media_id).attr('src', attachment.url);
    	    jQuery('.custom_media_url.'+media_id).val(attachment.url).change().select();
    	})
    	.open();
	});

	// Call Media Upload | Default No Image
	jQuery('.custom_media_upload_default_image').click( function(e){
    	e.preventDefault();
		media_id = jQuery(this).attr('id');

    	var custom_uploader = wp.media({
    	    title: 'Upload Default No Image',
			width: 200,
			height: 200,
    	    button: {
    	        text: 'Default No Image'
    	    },
    	    multiple: false  // Set this to true to allow multiple files to be selected
    	})
    	.on('select', function() {
    	    var attachment = custom_uploader.state().get('selection').first().toJSON();
    	    jQuery('.custom_media_url.'+media_id).val(attachment.url).change().select();
    	})
    	.open();
	});

	// Display MSW
	jQuery('.msw-button').click(function(){
		key = jQuery(this).attr('name');
		tag = jQuery(this).attr('tag');
		filter = jQuery(this).attr('filter');
		data = {'id': key, 'filter': filter};
		if( jQuery('#'+key).hasClass('active') ){
			jQuery('#'+key).removeClass('active');
		} else {
			jQuery('#'+key).addClass('active');
			if( !jQuery('#'+key+' .msw-wrapper').length ){
				jQuery('#'+key).find('.ajax-loading-message').addClass('loading');
				cdp_ajax_call( tag, data, '' ).done(function(result) {
					jQuery('#'+key).find('.ajax-loading-message').removeClass('loading');
				}).fail(function() {
				    alert('Data Note Saved');
				});
			}
		}
	});

	// MSW Controls
	jQuery('.msw-view-wrapper').on( 'click', '.msw-wrapper', function (e){
		if( jQuery(e.target).attr('name') ){
			path = jQuery(this).attr('name');
			tag = jQuery(this).attr('tag');
			key = jQuery(e.target).attr('class');
			item = jQuery(e.target).attr('name');
			element = jQuery(e.target);
			var value = [];
			jQuery('.msw-wrapper.'+tag+' ul.msw-included > li').each(function(){
				value.push(jQuery(this).attr('name'));
			});

			switch(key){
				case 'msw-add':
					value.push(item);
					jQuery('.msw-wrapper.'+tag+' ul.msw-included').append(element);
					jQuery(element).removeClass('msw-add').addClass('msw-remove');
					break;
				case 'msw-remove':
					if( jQuery.inArray(item, value) !== -1 ){
						value.splice( jQuery.inArray(item, value), 1);
						jQuery('.msw-wrapper.'+tag+' ul.msw-available').append(element);
					}
					jQuery(element).removeClass('msw-remove').addClass('msw-add');
					break;
				case 'msw-add-all':
					jQuery('.msw-wrapper.'+tag+' ul.msw-available > li').each(function(){
						value.push(jQuery(this).attr('name'));
						jQuery('.msw-wrapper.'+tag+' ul.msw-included').append(jQuery(this));
						jQuery(this).removeClass('msw-add').addClass('msw-remove');
					});
					break;
				case 'msw-remove-all':
					jQuery('.msw-wrapper.'+tag+' ul.msw-included > li').each(function(){
						jQuery('.msw-wrapper.'+tag+' ul.msw-available').append(jQuery(this));
						jQuery(this).removeClass('msw-remove').addClass('msw-add');
					});
					value = [];
					break;
			}
			data = {'path': path, 'value': value };
			cdp_ajax_call( 'saveAdminSettings', data, '#cdp-content-wrapper' ).done(function(result) {

			}).fail(function() {
			    alert('Data Note Saved...');
			});
		}
	});
	jQuery('.msw-view-wrapper').on( 'click', '.msw-window-title', function (e){
		if( jQuery(e.target).siblings('.msw-data-wrapper').hasClass('active') ){
			jQuery(e.target).siblings('.msw-data-wrapper').removeClass('active');
		} else {
			jQuery(e.target).siblings('.msw-data-wrapper').addClass('active');
		}
	});

	//Refresh Button
	jQuery('img.refresh-button').click( function(e){
		tag = jQuery(e.target).attr('tag');
		jQuery('.'+tag+' .msw-wrapper' ).remove();
		jQuery('.'+tag).removeClass('active');
	})

	// AJAX Call
	function cdp_ajax_call( fn, params, wrapper ){
		return jQuery.ajax({
			url: ajax_path,
			type: 'GET',
			headers: { Accept : 'application/json' },
			contentType: 'application/json',
			data: {'action': 'cdp_admin_handle_request', 'fn': fn, 'params': params},
			dataType: 'json',
			beforeSend: function(){
				if( wrapper != 'skip' ){
					jQuery(wrapper).addClass('saving');
					jQuery(wrapper).removeClass('not-saved');
				}
			},
			success: function(data){
				if( !jQuery.isEmptyObject(data['id']) ){
					jQuery('#'+data['id']).append(data['content']);
				}
			},
			complete: function(){
				if( wrapper != 'skip' ){
					jQuery(wrapper).addClass('saved');
					jQuery(wrapper).removeClass('saving');
					setTimeout( 'cdp_aftersave("'+wrapper+'")', 500);
				}
			},
			error: function(xhr, status, error) {
				//alert('Ajax call failed.');
				//alert(error);
			}
		});
	}

	function cdp_aftersave(wrapper){
		if( jQuery(wrapper).hasClass('saved')){
			jQuery(wrapper).removeClass('saved');
		}
	}

	//Uninstall
	jQuery('#cdp-uninstall-button').click(function(){
		jQuery('#cdp-uninstall-dialog').slideDown();
		jQuery('#cdp-uninstall-button').css({'display':'none'});
	});

	jQuery('#cdp-uninstall-yes').click( function(){
		var target_url = jQuery('#cdp-uninstall-button').attr('target');

		cdp_ajax_call( 'runCleanUninstall', '', '' ).done(function(result) {
			window.location = target_url;
		}).fail(function() {
		    alert('Was not able to clean uninstall.');
		});
	})

	jQuery('#cdp-uninstall-cancel').click( function(){
		jQuery('#cdp-uninstall-dialog').slideUp();
		jQuery('#cdp-uninstall-button').css({'display':'block'});
	})

	function check_import_status(){
		data = {'task': 'check_import_status' };
		cdp_ajax_call( 'initCron', data, 'skip' ).done(function(result) {
			jQuery('#feed-status-message').html(result['content']);
//			console.dir(result);
		}).fail(function() {
		    //alert('Could not check Import Status');
		});
	}

	jQuery(document).ready(function(){
		//setInterval(check_import_status, 10000);
		jQuery('.cdp-date-field').datepicker({ dateFormat: 'yy-mm-dd' });
	});
