<?php
namespace Wordpress\Plugins\CarDealerPress\Inventory\Api;

class cdp_database {

	static $settings;
	private $blog;

	function __construct(){
		global $wpdb;
		$this->wpdb = $wpdb;
		self::$settings = get_option('cardealerpress_settings');
		$this->blog = get_current_blog_id();
	}

	function cdp_data_db_update($data){
		$table = 'cdp_data';
		$update = array('data_value'=>$data['value'] );
		$where = array('blog_id'=>$this->blog,'data_key'=>$data['key']);
		$format = array('%s');
		$where_format = array('%d','%s');
		$this->wpdb->update($table, $update, $where, $format, $where_format);
	}

	function cdp_db_init($key, $params = array()){
		$this->parameters = $params;
		$this->page = (isset($params['page'])? $params['page']: 1);
		$this->cdp_scrub_params();
		$function = 'cdp_'.$key.'_request';

		return $this->$function();
	}

	function cdp_disclaimer_request(){
		$this->sql_query_params_prepare = array($this->blog,'disclaimer');
		$this->sql_query_prepare = 'SELECT data_value FROM cdp_data WHERE blog_id = %d AND data_key = %s';
		$results = $this->cdp_sql_request_prepare();
		if( !empty($results[0]['data_value']) ){
			return $results[0]['data_value'];
		} else {
			return '';
		}

	}

	function cdp_searchtotal_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('manual_sort');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'');
		$results = $this->cdp_sql_request_prepare();
		return $results[0]['Total'];
	}

	function cdp_make_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('make','model','trim','manual_sort','tags');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT Make, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Make ORDER BY Make';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_model_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('model', 'trim','manual_sort','tags');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT Model, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Model ORDER BY Model';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_trim_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('trim','manual_sort','tags');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT Trim, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Trim ORDER BY Trim';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_year_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('year_to','year_from','manual_sort','tags');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT Year, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Year ORDER BY Year DESC';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_vehicleclass_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('vehicleclass','body','make','model','trim','manual_sort','tags','transmission','drivetrain','fuel_type');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT Vehicleclass, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Vehicleclass ORDER BY Vehicleclass';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_body_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('body','make','model','trim','manual_sort','tags');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT Body, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Body ORDER BY Body';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_transmission_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('transmission','manual_sort','tags');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT Transmission, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Transmission ORDER BY Transmission';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_drivetrain_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('drivetrain','manual_sort','tags');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT Drivetrain, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Drivetrain ORDER BY Drivetrain';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_fuel_type_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('fuel_type','manual_sort','tags');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT Fuel_type, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Fuel_type ORDER BY Fuel_type';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_color_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('manual_sort','tags','color');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT color_map as Color, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Color_Map ORDER BY Color_Map';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_color_int_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('manual_sort','tags','color_int');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT color_map_int as Color_int, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Color_Map_int ORDER BY Color_Map_int';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_states_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('vehicleclass','geo_state','geo_city','dealer','make','model','trim','manual_sort','tags','search');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT geo_state, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY geo_state ORDER BY geo_state';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_cities_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('vehicleclass','geo_city','dealer','make','model','trim','manual_sort','tags');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT geo_city, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY geo_city ORDER BY geo_city';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_zips_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('geo_zip','manual_sort');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT geo_zip, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY geo_zip ORDER BY geo_zip';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_dealers_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('vehicleclass','dealer','make','model','trim','manual_sort','tags');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT Dealer, count(*) Total FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY Dealer ORDER BY Dealer';
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_tags_request(){
		/*Prepare patch on 10/27/2017*/
		$results = array(); $exclude = array('manual_sort');
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT tags FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' GROUP BY TAGS ';
		$tags = $this->cdp_sql_request_prepare();
		if( $tags ){
			foreach($tags as $tag_string){
				$tag_array = explode(',', $tag_string['tags']);
				foreach($tag_array as $tag){
					if( !in_array($tag, $results) ){
						$results[] = $tag;
					}
				}
			}
		}
		sort($results);
		return $results;
	}

	function cdp_company_request(){
		/*Prepare patch on 10/27/2017*/
		$results = array();
		$this->sql_query_prepare = 'SELECT * FROM cdp_companies WHERE blog_id = %d AND company_id = %d';
		$this->sql_query_params_prepare = array($this->blog, self::$settings['vehicle_management_system']['company_information']['id']);
		$raw = $this->cdp_sql_request_prepare();
		foreach($raw as $key=>$row){
			$new_row = array();
			foreach($row as $column=>$value){
				$new_row[$column] = maybe_unserialize($value);
			}
			$results[$key] = $new_row;
		}
		return $results;
	}

	function cdp_company_dealer_request($dealer=0){
		/*Prepare patch on 10/27/2017*/
		$results = array();
		$this->sql_query_prepare = 'SELECT * FROM cdp_companies WHERE blog_id = %d AND company_id = %d AND dealer_id = %d';
		$this->sql_query_params_prepare = array($this->blog, self::$settings['vehicle_management_system']['company_information']['id'], $dealer);
		$raw = $this->cdp_sql_request_prepare();
		foreach($raw as $key=>$row){
			$new_row = array();
			foreach($row as $column=>$value){
				$new_row[$column] = maybe_unserialize($value);
			}
			$results[$key] = $new_row;
		}
		return $results;
	}

	/*Deprecated*/
	function cdp_get_company(){
		/*Prepare patch on 10/27/2017*/
		$results = array();
		$this->sql_query_prepare = 'SELECT * FROM cdp_companies WHERE blog_id = %d AND company_id = %d';
		$this->sql_query_params_prepare = array($this->blog, self::$settings['vehicle_management_system']['company_information']['id']);
		$raw = $this->cdp_sql_request_prepare();
		foreach($raw as $key=>$row){
			$new_row = array();
			foreach($row as $column=>$value){
				$new_row[$column] = maybe_unserialize($value);
			}
			$results[$key] = $new_row;
		}
		return $results;
	}

	function cdp_inventory_update_check(){
		/*Prepare patch on 10/27/2017*/
		$this->sql_query_prepare = 'SELECT * FROM cdp_companies WHERE blog_id = %d AND company_id = %d AND inventory_last_updated <= %d';
		$this->sql_query_params_prepare = array($this->blog, self::$settings['vehicle_management_system']['company_information']['id'], (time() - (3600 * 4) ));
		$results = $this->cdp_sql_request_prepare();
		return (empty($results)? FALSE: TRUE);
	}

	function cdp_inventory_request(){
		/*Prepare patch on 10/27/2017*/
		$exclude = array('manual_sort');
		$per_page = self::$settings['vehicle_management_system']['theme']['per_page'];
		if( !is_numeric($this->page) or $this->page <= 0 ){
			$this->page = 1;
		}
		$limit = ' LIMIT '.( ($this->page - 1) * $per_page ).','.$per_page;
		$this->cdp_search_string_prepare($exclude);
		$this->sql_query_prepare = 'SELECT * FROM cdp_inventory_'.$this->blog.($this->sql_search_string? $this->sql_search_string:'').' ORDER BY '.$this->cdp_sort_filters().' '.$limit;
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_inventory_special_request( $request = '', $param = '' ){
		/*Used by Sitemap - no user input*/
		$columns = ( $request? $request: 'vin,saleclass,make,model,trim,year,vehicleclass,description,geo_state,geo_city,video,thumbnail,updated');
		$this->sql_query = 'SELECT '.$columns.' FROM cdp_inventory_'.$this->blog.' WHERE blog_id = "'.$this->blog.'" AND company_id = "'.self::$settings['vehicle_management_system']['company_information']['id'].'" '.($param? 'AND '.$param: '');
		$this->sql_query .= ($request? ' GROUP BY '.$request.' ORDER BY '.$request : ' ORDER BY make,model');
		$results = $this->cdp_sql_request();
		return $results;
	}

	function cdp_inventory_video_check(){
		/*Prepare patch on 10/27/2017*/
		$this->sql_query_prepare = 'SELECT count(*) Total FROM cdp_inventory_'.$this->blog.' WHERE blog_id = %d AND company_id = %d AND video <> "" ';
		$this->sql_query_params_prepare = array($this->blog, self::$settings['vehicle_management_system']['company_information']['id']);
		$results = $this->cdp_sql_request_prepare();
		return $results;
	}

	function cdp_sort_filters(){
		if( isset($this->parameters['manual_sort']) && $this->parameters['manual_sort'] != '0' ){
			$results = ' ';
			$type = $this->parameters['manual_sort'];
		} else {
			$results = '(Sort > 0 ) desc, sort asc, ';
			$type = self::$settings['vehicle_management_system']['sort']['default'];
		}

		switch($type){
			case 'makeModel':
				$results .= 'Make, Model';
				break;
			case 'makeModelD':
				$results .= 'Make Desc, Model';
				break;
			case 'createdA':
				$results .= 'Created';
				break;
			case 'createdD':
				$results .= 'Created Desc';
				break;
			case 'yearA':
				$results .= 'Year';
				break;
			case 'yearD':
				$results .= 'Year Desc';
				break;
			case 'priceA':
				$results .= 'Pricesort, Sortprice';
				break;
			case 'priceD':
				$results .= 'Pricesort, Sortprice Desc';
				break;
			case 'odometerA':
				$results .= 'Odometer';
				break;
			case 'odometerD':
				$results .= 'Odometer Desc';
				break;
		}
		return $results;

	}

	function cdp_scrub_params( ){
		$exclude = array( 'taxonomy','per_page','photo_view','page');
		if( $this->parameters ){
			foreach( $exclude as $item ){
				if( isset($this->parameters[$item]) ){
					unset($this->parameters[$item]);
				}
			}
		}
		// edge case
		if( isset($this->parameters['saleclass']) && strtolower($this->parameters['saleclass']) == 'all' ){
			unset($this->parameters['saleclass']);
		}
	}

	function cdp_search_string($exclude = array()){
		$results = ' WHERE company_id = '.self::$settings['vehicle_management_system']['company_information']['id'].' AND blog_id='.$this->blog.' ';

		$passable = array('dealer_id', 'stock', 'vin', 'saleclass', 'certified', 'make', 'model', 'trim', 'year_to', 'year_from', 'price_to', 'price_from', 'odometer_to', 'odometer_from', 'search', 'tags', 'body', 'vehicleclass', 'geo_state', 'geo_city', 'geo_zip', 'dealer', 'fuel_type');
		$special = array('saleclass','make','tags','price_to','price_from','odometer_to','odometer_from','year_to','year_from','certified','search');
		$newMake_filter = self::$settings['vehicle_management_system']['data']['makes_new'];
		if( isset($this->parameters['saleclass']) && strtolower($this->parameters['saleclass']) == 'new' && !empty($newMake_filter) ){
			foreach($exclude as $key=>$value){
				if( $value == 'make' ){
					unset($exclude[$key]);
				}
			}
		}
		if( $this->parameters ){
			foreach($this->parameters as $key=>$param){
				if( ( empty($exclude) || !in_array($key, $exclude) ) && in_array($key,$passable) ){
					$results .= 'AND ';
					if( in_array($key, $special) ){
						switch($key){
							case 'saleclass':
								if( strtolower($param) == 'new' && !empty($newMake_filter) ){
									if( isset($this->parameters['make']) && !empty($this->parameters['make']) ){
										$results .= $key.'="' .rawurldecode($param). '" ';
									} else {
										$count = count($newMake_filter); $i = 1; $search = '';
										foreach($newMake_filter as $make){
											$search .= ($i == $count? ' "'.$make.'" ': ' "'.$make.'", '); $i++;
										}
										$results .= $key.'="' .rawurldecode($param). '" AND make in ('.$search.') ';
									}
								} else {
									$results .= $key.'="' .rawurldecode($param). '" ';
								}
								break;
							case 'make':
								if( isset($this->parameters['saleclass']) && strtolower($this->parameters['saleclass']) == 'new' && !empty($newMake_filter) ){
									$count = count($newMake_filter); $i = 1; $search = '';
									foreach($newMake_filter as $make){
										$search .= ($i == $count? ' "'.$make.'" ': ' "'.$make.'", '); $i++;
									}
									$results .= $key.' in ('.$search.') ';
								} else {
									$results .= $key.'="' .rawurldecode($param). '" ';
								}
								break;
							case 'tags':
								$tags = explode(',',rawurldecode($param)); $count = count($tags); $i = 1; $search = '';
								foreach($tags as $tag){
									$more = ($i != $count? ' AND ': ''); $i++;
									$search .= 'FIND_IN_SET("'.$tag.'", tags) '.$more;
								}
								$results .= ( $search? '('.$search.')': '');
								break;
							case 'price_to':
							case 'price_from':
								$results .= 'sortprice'.(strpos($key,'_to') !== FALSE? '<=':'>=').$param.' ';
								break;
							case 'odometer_to':
							case 'odometer_from':
								$results .= 'odometer'.(strpos($key,'_to') !== FALSE? '<=':'>=').$param.' ';
								break;
							case 'year_to':
							case 'year_from':
								$results .= 'year'.(strpos($key,'_to') !== FALSE? '<=':'>=').$param.' ';
								break;
							case 'certified':
								$results .= 'certified'.($param == 'Yes'? '=1': '=0').' ';
								break;
							case 'search':
								$fields = array('stock','vin','headline','description','make','model','trim','exterior','interior','body','vehicleclass','tags','engine','transmission', 'drivetrain','extra');
								$textStrings = explode(' ',rawurldecode($param)); $count = count($textStrings); $countB = count($fields); $i = 1; $result = $search = '';
								foreach($textStrings as $textString){
									$more = ($i != $count? ' AND ': ''); $i++; $search = '';$iB = 1;
									foreach($fields as $field){
										$moreB = ($iB != $countB? ' OR ': ''); $iB++;
										$search .= $field.' like "%'.$textString.'%" '.$moreB;
									}
									$result .= ( $search? '('.$search.')'.$more: '');
								}
								$results .= ( $result? '( '.$result.' )': '');
								break;
						}
					} else {
						$results .= $key.'="' .rawurldecode($param). '" ';
					}
				}
			}
		}

		return $results;
	}

	function cdp_search_string_prepare($exclude = array()){
		$this->sql_search_string = ' WHERE company_id = %d AND blog_id = %d ';
		$this->sql_query_params_prepare = array(self::$settings['vehicle_management_system']['company_information']['id'], $this->blog);

		$passable = array('dealer_id', 'stock', 'vin', 'saleclass', 'certified', 'make', 'model', 'trim', 'year_to', 'year_from', 'price_to', 'price_from', 'odometer_to', 'odometer_from', 'search', 'tags', 'body', 'vehicleclass', 'geo_state', 'geo_city', 'geo_zip', 'dealer', 'transmission', 'drivetrain', 'fuel_type', 'model_code', 'engine', 'city_to', 'city_from', 'highway_to', 'highway_from', 'color', 'color_int','year');
		$special = array('saleclass','make','tags','price_to','price_from','odometer_to','odometer_from', 'year_to','year_from','certified','search','model_code', 'engine', 'city_to', 'city_from', 'highway_to', 'highway_from', 'color', 'color_int','year');
		$newMake_filter = self::$settings['vehicle_management_system']['data']['makes_new'];

		foreach( $this->parameters as $key=>$value ){
			if( empty($value) || trim($value) == false ){
				unset($this->parameters[$key]);
			}
		}

		if( $this->parameters ){
			foreach($this->parameters as $key=>$param){
				if( ( empty($exclude) || !in_array($key, $exclude) ) && in_array($key,$passable) && !empty($param) ){
					$this->sql_search_string .= ' AND ';
					if( in_array($key, $special) ){
						switch($key){
							case 'saleclass':
								if( strtolower($param) == 'new' && !empty($newMake_filter) ){
									$search_placeholders = implode( ', ', array_fill( 0, count( $newMake_filter ), '%s' ) );
									// saleclass
									$this->sql_search_string .= $key.' = %s';
									$this->sql_query_params_prepare[] = rawurldecode($param);
									// new make check
									$this->sql_search_string .= ' AND make in ('.$search_placeholders.') ';
									foreach( $newMake_filter as $id=>$make){
										$this->sql_query_params_prepare[] = $make;
									}
								} else {
									$this->sql_search_string .= $key.' = %s';
									$this->sql_query_params_prepare[] = rawurldecode($param);
								}
								break;
							case 'make':
								if( isset($this->parameters['saleclass']) && strtolower($this->parameters['saleclass']) == 'new' && !empty($newMake_filter) ){
									if( in_array($param, $newMake_filter) ){
										$this->sql_search_string .= $key.' = %s';
										$this->sql_query_params_prepare[] = rawurldecode($param);
									} else {
										$this->sql_search_string .= $key.' = %s';
										$this->sql_query_params_prepare[] = '';
									}
								} else {
									$this->sql_search_string .= $key.' = %s';
									$this->sql_query_params_prepare[] = rawurldecode($param);
								}
								break;
							case 'tags':
								$tags = explode(',',rawurldecode($param)); $count = count($tags); $i = 1; $search = '';
								$this->sql_search_string .= '(';
								foreach($tags as $tag){
									$more = ($i != $count? ' AND ': ''); $i++;
									$this->sql_search_string .= ' FIND_IN_SET(%s, tags) '.$more;
									$this->sql_query_params_prepare[] = ''.$tag.'';
								}
								$this->sql_search_string .= ')';
								break;
							case 'price_to':
							case 'price_from':
								$this->sql_search_string .= 'sortprice'.(strpos($key,'_to') !== FALSE? '<= %d':'>= %d');
								$this->sql_query_params_prepare[] = $param;
								break;
							case 'odometer_to':
							case 'odometer_from':
								$this->sql_search_string .= 'odometer'.(strpos($key,'_to') !== FALSE? '<= %d':'>= %d');
								$this->sql_query_params_prepare[] = $param;
								break;
							case 'year':
								$this->sql_search_string .= 'year = %d';
								$this->sql_query_params_prepare[] = $param;
								break;
							case 'year_to':
							case 'year_from':
								$this->sql_search_string .= 'year'.(strpos($key,'_to') !== FALSE? '<= %d':'>= %d');
								$this->sql_query_params_prepare[] = $param;
								break;
							case 'certified':
								$this->sql_search_string .= 'certified = %d';
								$this->sql_query_params_prepare[] = ($param == 'Yes'? '1': '0');
								break;
							case 'color':
								$this->sql_search_string .= 'color_map = %s';
								$this->sql_query_params_prepare[] = $param;
								break;
							case 'color_int':
								$this->sql_search_string .= 'color_map_int = %s';
								$this->sql_query_params_prepare[] = $param;
								break;
							case 'model_code':
								$this->sql_search_string .= 'model_code like %s';
								$this->sql_query_params_prepare[] = '%'.$param.'%';
								break;
							case 'engine':
								$this->sql_search_string .= 'engine like %s';
								$this->sql_query_params_prepare[] = '%'.$param.'%';
								break;
							case 'city_to':
							case 'city_from':
								$this->sql_search_string .= 'city '.(strpos($key,'_to') !== FALSE? '<= %d':'>= %d');
								$this->sql_query_params_prepare[] = $param;
								break;
							case 'highway_to':
							case 'highway_from':
								$this->sql_search_string .= 'highway '.(strpos($key,'_to') !== FALSE? '<= %d':'>= %d');
								$this->sql_query_params_prepare[] = $param;
								break;
							case 'search':
								$fields = array('stock','vin','headline','description','make','model','trim','exterior','interior','body','vehicleclass','tags','engine','transmission', 'drivetrain','extra');
								$textStrings = explode(' ',trim(rawurldecode($param))); $count = count($textStrings); $countB = count($fields); $i = 1; $result = $search = '';
								$this->sql_search_string .= '(';
								foreach($textStrings as $textString){
									if( !empty($textString) ){
										$more = ($i != $count? ' AND ': ''); $i++; $search = '';$iB = 1;
										$this->sql_search_string .= '(';
										foreach($fields as $field){
											$moreB = ($iB != $countB? ' OR ': ''); $iB++;
											$this->sql_search_string .= $field.' like %s '.$moreB;
											$this->sql_query_params_prepare[] = '%'.$textString.'%';
										}
										// Numeric Year
										if( is_numeric($textString) ){
											$this->sql_search_string .= ' OR year like %s ';
											$this->sql_query_params_prepare[] = '%'.$textString.'%';
										}
										$this->sql_search_string .= ') '.$more;
									} else {
										$i++;
									}
								}
								$this->sql_search_string .= ')';
								break;
						}
					} else {
						$this->sql_search_string .= $key.'= %s';
						$this->sql_query_params_prepare[] = rawurldecode($param);
					}
				}
			}
		}
	}

	function cdp_sql_request(){

		if( $this->sql_query ){
			return $this->wpdb->get_results($this->sql_query, ARRAY_A);
		} else {
			return array();
		}

	}

	function cdp_sql_request_prepare(){

		$query = $this->wpdb->prepare($this->sql_query_prepare, $this->sql_query_params_prepare);
		return $this->wpdb->get_results($query, ARRAY_A);
	}

	function cdp_sql_query(){

		if( $this->sql_query ){
			return $this->wpdb->query($this->sql_query);
		} else {
			return array();
		}
	}

	function cdp_admin_get_custom_imports($id = 0){
		if( $id ){
			$this->sql_query = 'SELECT * FROM cdp_data WHERE blog_id='.$this->blog.' AND data_key = "import" AND dealer_id = '.$id;
			$results = $this->cdp_sql_request();
			return $results;
		}
		return array();
	}

	function cdp_admin_update_sort( $data ){
		/*Used by Sort Settings - no user input*/

		if($data){
			foreach($data as $key=>$values){
				$query = 'UPDATE cdp_inventory_'.$this->blog.' SET Sort = '.$values['sort'].' ';
				unset($values['name']); unset($values['sort']);
				$this->parameters = $values;
				$query .= $this->cdp_sort_string();
				$this->wpdb->query($query);
			}
		}
	}

	function cdp_admin_sort_count( $params = array() ){
		/*Used by Sort Settings - no user input*/
		$query = 'SELECT count(*) Counts from cdp_inventory_'.$this->blog.' ';
		unset($params['name']); unset($params['sort']);
		if($params){
			$this->parameters = $params;
			$query .= $this->cdp_sort_string();
			$this->sql_query = $query;
			$results = $this->cdp_sql_request();
			return $results[0]['Counts'];
		} else {
			return 0;
		}
	}

	function cdp_sort_string(){
		/*Used by Sort Settings - no user input*/
		$results = ' WHERE company_id = '.self::$settings['vehicle_management_system']['company_information']['id'].' and blog_id='.$this->blog.' ';
		foreach($this->parameters as $key=>$param){
			if( $key != 'saleclass' || ($key == 'saleclass' && $param != 'all') ){
				$results .= 'AND ';
				if($key == 'saleclass' && $param == 'cert'){
					$results .= 'saleclass="used" and certified=1 ';
				}else if($key == 'tags'){
					$results .= $key.' like "%'.$param.'%" ';
				} else {
					$results .= $key.'="'.$param.'" ';
				}
			}
		}
		return $results;
	}

	function delete_manual_dealer($dealer = 0){
		if( $dealer ){
			// Removes cdp_data
			$this->sql_query = 'DELETE FROM cdp_data WHERE blog_id = "'.$this->blog.'" AND data_key = "dealer" AND dealer_id = "'.$dealer.'"';
			$this->cdp_sql_query();
			// Removes cdp_companies
			$this->sql_query = 'DELETE FROM cdp_companies WHERE blog_id = "'.$this->blog.'" AND dealer_id = "'.$dealer.'"';
			$this->cdp_sql_query();
			// Removes Inventory
			$this->sql_query = 'DELETE FROM cdp_inventory_'.$this->blog.' WHERE blog_id = "'.$this->blog.'" AND dealer_id = "'.$dealer.'"';
			$this->cdp_sql_query();
		}
	}

	function delete_custom_import($data_id = 0){
		if( $data_id ){
			$this->sql_query = 'DELETE FROM cdp_data WHERE data_id = '.$data_id.' AND data_key = "import"';
			$this->cdp_sql_query();
			set_transient('cdp_custom_import_update', 'Inventory imports need to be re-ran to reflect recent updates to custom imports.', 3600 * 4);
		}
	}
}

?>
