<?php
namespace Wordpress\Plugins\CarDealerPress\Inventory\Api;

	$vehicle = itemize_vehicle($inventory);
	$price = get_price_display($vehicle['prices'], $this->company, $vehicle['saleclass'], $vehicle['vin'], 'inventory', $theme_settings['price_text'] );
	$vehicle['primary_price'] = $price['primary_price'];
	$parameters['saleclass'] = $vehicle['saleclass'];
	$loan_parameters = array('make'=>$vehicle['make']['name'],'model'=>$vehicle['model']['name'], 'trim'=> $vehicle['trim']['name'], 'year'=>$vehicle['year'], 'saleclass'=>$vehicle['saleclass']);
	apply_gravity_form_hooks( $vehicle );

	$traffic_source = isset( $_COOKIE[ 'cardealerpress-traffic-source' ] ) ? $_COOKIE[ 'cardealerpress-traffic-source' ] : false;
	$traffic_source = $this->sanitize_inputs( $traffic_source );

	usort($vehicle['dealer_options'], 'sort_length' );

	$form_subject = $vehicle['year'] . ' ' . $vehicle['make']['name'] . ' ' . $vehicle['model']['name'] . ' ' . $vehicle['stock_number'];
	$form_submit_url = $this->options[ 'vehicle_management_system' ]['host'] . '/' . $this->options[ 'vehicle_management_system' ][ 'company_information' ][ 'id' ] . '/forms/create/';
?>



<div id="inventory-wrapper"> <!-- 2nd Wrapper -->
	<div id="inventory-detail"> <!-- Detail Body -->
		<div id="inventory-top"> <!-- Detail Top -->
			<div class="inventory-breadcrumb-wrapper"> <!-- SEO/Taxonomy -->
				<div class="breadcrumbs"><?php echo display_breadcrumb( $parameters, $this->company, $this->options['vehicle_management_system' ]['custom_contact'], $vehicle['saleclass'] ); ?></div> <!-- Breadcrumbs -->
				<div class="inventory-print"> <!-- Print -->
					<a id="friendly-print" onclick="window.open('?print_page','popup','width=800,height=900,scrollbars=yes,resizable=no,toolbar=no,directories=no,location=no,menubar=yes,status=no,left=0,top=0'); return false">Print</a>
				</div>
			</div>
			<div id="inventory-headline"> <!-- Headline -->
				<h2>
					<span class="inventory-saleclass"><?php echo $vehicle['saleclass']; ?></span>
					<span class="inventory-year"><?php echo $vehicle['year']; ?></span>
					<span class="inventory-make"><?php echo $vehicle['make']['name']; ?></span>
					<span class="inventory-model"><?php echo $vehicle['model']['name']; ?></span>
					<span class="inventory-trim"><?php echo $vehicle['trim']['name']; ?></span>
					<span class="inventory-drive-train"><?php echo $vehicle['drive_train']; ?></span>
					<span class="inventory-body-style"><?php echo $vehicle['body_style']; ?></span>

				</h2>
				<?php
					if ( !empty( $vehicle['headline'] ) ){
						$value = '<div id="inventory-headline-text">' . $vehicle['headline'] . '</div>';
						echo $value;
					}
				?>

			</div>
		</div> <!-- Detail Top End-->
		<div id="inventory-media-wrapper">
			<div id="inventory-contact-information"> <!-- Contact Information -->
				<?php
					$value = '<div id="inventory-contact-details">';
					$value .= '<span id="inventory-contact-greeting">'.$vehicle['contact_info']['greeting'].'</span><br/><strong id="inventory-contact-dealer">'.get_dealer_contact_name( $vehicle['contact_info'], $this->options['vehicle_management_system' ]['custom_contact'], $vehicle['saleclass'] ).' </strong>';
					$value .= ' <span id="inventory-contact-phone">: <strong>'.get_dealer_contact_number( $vehicle['contact_info'], $this->options['vehicle_management_system' ]['custom_contact'], $vehicle['saleclass'] ).'</strong></span>';
					$value .= '</div>';
					echo $value;
				?>
			</div> <!-- Contact Information End -->
		</div>
		<div id="inventory-detail-information"> <!-- Detail Information -->
			<div id="inventory-column-left"> <!-- Column Left -->
				<div id="inventory-slideshow-text">
					Click Image to Enlarge
				</div>
				<div id="inventory-slideshow">
					<?php
						echo get_photo_detail_display( $vehicle, $theme_settings['default_image_tab'], '' );
						if( count( $vehicle['photos'] ) > 1 ) {
							echo '<div id="inventory-nav-button" class="'.( count($vehicle['photos']) > 6 ? 'active' : 'hidden').'">View All Images</div>';
						}
					?>
				</div>
				<?php
					if( $theme_settings['display_tags'] ){
						apply_special_tags( $vehicle['tags'], $vehicle['prices']['on_sale'], $vehicle['certified'], $vehicle['video']);
						if( !empty( $vehicle['tags'] ) ){
							echo '<div class="inventory-detail-tags">';
								$tag_icons = build_tag_icons( $default_tag_names, $custom_tag_icons, $vehicle['tags'], $vehicle['vin']);
								echo $tag_icons;
							echo '</div>';
						}
					}
				?>

				<?php
					if ( !empty( $vehicle['carfax']) && strtolower($vehicle['saleclass']) == 'used') {
						echo cdp_display_carfax($vehicle['vin'], $vehicle['carfax'], $vehicle['carfax_image_url'] );
					}

					if( $vehicle['autocheck'] ){
						echo display_autocheck_image( $vehicle['vin'], $vehicle['saleclass'], $type );
					}
				?>
			</div> <!-- Column Left End -->
			<div id="inventory-column-middle"> <!-- Column Middle -->
				<div id="inventory-price-wrapper">
					<?php
						echo $price['hidden_prices'];
						echo $price['primary_text'].$price['compare_text'].$price['msrp_text'].$price['expire_text'];
						echo get_loan_value($theme_settings['loan'], $price['primary_price'], $loan_parameters);
					?>
				</div>
				<div id="inventory-vehicle-overview">
					<?php
						$vehicle_info = '';
						if ( $vehicle['certified'] != 'false' ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Certified:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">Yes</div>';
							$vehicle_info .= '</div>';

						}

						if ( !empty( $vehicle['body_style'] ) ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Body Style:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">' . $vehicle['body_style'] . '</div>';
							$vehicle_info .= '</div>';
						}

						if ( !empty( $vehicle['exterior_color'] ) ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Ext. Color:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">' . $vehicle['exterior_color'] . '</div>';
							$vehicle_info .= '</div>';
						}

						if ( !empty( $vehicle['interior_color'] ) ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Int. color:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">' . $vehicle['interior_color'] . '</div>';
							$vehicle_info .= '</div>';
						}

						if ( !empty( $vehicle['engine'] ) ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Engine:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">' . $vehicle['engine'] . '</div>';
							$vehicle_info .= '</div>';
						}

						if ( !empty( $vehicle['fuel_type'] ) ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Fuel Type:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">' . $vehicle['fuel_type'] . '</div>';
							$vehicle_info .= '</div>';
						}

						if ( !empty( $vehicle['transmission'] ) ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Transmission:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">' . $vehicle['transmission'] . '</div>';
							$vehicle_info .= '</div>';
						}

						if ( !empty( $vehicle['drive_train'] ) ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Drivetrain:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">' . $vehicle['drive_train'] . '</div>';
							$vehicle_info .= '</div>';
						}

						if ( !empty( $vehicle['odometer'] ) ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Odometer:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">' . $vehicle['odometer'] . '</div>';
							$vehicle_info .= '</div>';
						}

						if ( !empty( $vehicle_info ) ) { $vehicle_info .= '<br>'; }

						if ( !empty( $vehicle['vin'] ) ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Vin:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">' . $vehicle['vin'] . '</div>';
							$vehicle_info .= '</div>';
						}

						if ( !empty( $vehicle['stock_number'] ) ) {
							$vehicle_info .= '<div class="inventory-vehicle-overview-wrap">';
							$vehicle_info .= '<div class="inventory-vehicle-overview-left">Stock #:</div>';
							$vehicle_info .= '<div class="inventory-vehicle-overview-right">' . $vehicle['stock_number'] . '</div>';
							$vehicle_info .= '</div>';
						}

						echo $vehicle_info;

					?>
				</div>
				<?php
					$fuel_info = get_fuel_economy_display( $vehicle['fuel_economy'], $country_code, 1 );
					if( !empty($fuel_info) ){
						echo $fuel_info;
					}

				?>
			</div> <!-- Column Middle End -->
			<div id="inventory-column-right"> <!-- Column Right -->
				<?php
					if( function_exists('gravity_form') && !empty($theme_settings['detail_gform_id']) ){
						$form ='<div class="inventory-forms">';
						$form .= '<div class="form-wrapper"><div id="info-form-id-'.$theme_settings['detail_gform_id'].'" class="inventory-form form-display-wrap form-'.$theme_settings['detail_gform_id'].'" name="form-id-'.$theme_settings['detail_gform_id'].'">';
						$form .= do_shortcode('[gravityform id='.$theme_settings['detail_gform_id'].' title=true description=false]');
						$form .= '</div></div></div>';
						echo $form;
					}
				?>
				<?php
					if( !empty($theme_settings['forms']) ){
						$gform_buttons = get_gform_button_display( $theme_settings['forms'], $vehicle['saleclass'] );
						echo $gform_buttons;
					}
					echo get_loan_calculator($theme_settings['loan'], $vehicle['primary_price'], TRUE, $loan_parameters);
				?>
			</div> <!-- Column Right End -->
			<div id="inventory-detail-specs"> <!-- Detail Specs -->
				<?php
				echo get_vehicle_detail_display( $vehicle['dealer_options'], $vehicle['description'], $theme_settings['show_standard_eq'], $vehicle['standard_equipment'], $theme_settings['default_info_tab']);
				?>
			</div>  <!-- Detail Specs End -->

			<?php //inventory Similar Vehicles
				if( $theme_settings['display_similar'] ){
					echo '<div id="detail-similar-wrapper">';
					echo get_similar_vehicles( $this->vms, $vehicle['vin'], $vehicle['saleclass'], $vehicle['vehicle_class'], $price['primary_price'], $vehicle['make']['name'], $this->options['vehicle_management_system' ]['data']['makes_new'], array( 'city' => $city, 'state' => $state) );
					echo '</div>';
				}
			?>

			<div id="inventory-disclaimer">
				<p>
				<?php
					//echo !empty( $inventory ) ? '<p>' . $inventory[ 0 ]->disclaimer . '</p>' : NULL;
					echo urldecode(stripslashes(get_db_disclaimer()));
				?>
				</p>
			</div>
			<?php echo cdp_hidden_vehicle_data($vehicle); ?>
			<?php
				if ( is_active_sidebar( 'vehicle-detail-page' ) ) :
					echo '<div id="inventory-widget-area" class="sidebar">';
						dynamic_sidebar( 'vehicle-detail-page' );
					echo '</div>';
				endif;
			?>
		</div> <!-- Detail Information End -->
	</div> <!-- Detail Body End-->
</div>  <!-- 2nd Wrapper End -->
