<?php

namespace Wordpress\Plugins\CarDealerPress\Inventory\Api;

	$this->parameters[ 'saleclass' ] = isset( $this->parameters[ 'saleclass' ] ) ? ucwords( $this->parameters[ 'saleclass' ] ) : 'All';

	//Cookie URL
	$rules = get_option( 'rewrite_rules' ); $url_rule = ( isset($rules['^(inventory)']) ) ? TRUE : FALSE;

	$this->page_url = 'http'.(isset($_SERVER['HTTPS']) ? 's' : '').'://'."$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
	$this->page_referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER']: '';
	setcookie('cdp_page_url',$this->page_url, 0, '/' );

	$site_url = site_url();

	if( $this->company ){
		$company_zip = $this->company->zip;
		$city = $this->company->city;
		$state = $this->company->state;
		$company_name = strtoupper( $this->company->name );
		$country_code =	$this->company->country_code;

		//The seo_hack was in the inital setup
		if( !empty($this->company->seo) ){
			$seo_hack = array( 'city' => $this->company->seo->city , 'state' => $this->company->seo->state , 'country_code' => $country_code );
			$this->seo_headers->apply_headers( $this->parameters, $seo_hack );
		}
	}


	$page = isset( $this->parameters['vin'] ) ? 'detail' : 'list';

	$ajax_script = admin_url('admin-ajax.php');
	$dependent_scripts = array('jquery','jquery-ui-core','jquery-ui-tabs','jquery-ui-dialog','jquery-ui-slider' );
	foreach( $dependent_scripts as $dependent ) {
		wp_enqueue_script( $dependent );
	}

	wp_enqueue_style( 'cdp_jquery_ui_style', self::$plugin_information[ 'PluginURL' ] . '/application/assets/css/jquery-css/jquery-css.css' );

	//jQuery Cookie
	wp_enqueue_script( 'cdp_jquery_cookie' , self::$plugin_information[ 'PluginURL' ] . '/application/assets/js/jquery-cookie/js.cookie.js' , array( 'jquery' ) , '2.1.3' );
	$gform_class = '';
	switch( $page ) {
		case 'detail':
			wp_enqueue_script( 'cdp_inventory_cycle_js' , self::$plugin_information[ 'PluginURL' ] . '/application/assets/js/jquery-cycle/cycle2.js' , array( 'jquery' ) , '2.1.5' , true );
			wp_enqueue_script( 'cdp_inventory_light_js' , self::$plugin_information[ 'PluginURL' ] . '/application/assets/js/jquery-lightbox/2.0/js/lightbox.js' , array( 'jquery' ) , '2.11.3' , true );
			wp_enqueue_style( 'cdp_inventory_light', self::$plugin_information[ 'PluginURL' ].'/application/assets/js/jquery-lightbox/2.0/css/lightbox.css', array(), '2.11.3' );

			if( function_exists('gravity_form_enqueue_scripts') ){
				if( $this->options['vehicle_management_system']['theme']['detail_gform_id'] ){
					$gform_element = '<div style="display: none;" id="inventory-gform-id" form="'.$this->options['vehicle_management_system']['theme']['detail_gform_id'].'"></div>';
					$gform_class = 'inventory_get_gform';
					gravity_form_enqueue_scripts($this->options['vehicle_management_system']['theme']['detail_gform_id'], true);
				}
			}
			break;
		case 'list':

			$search_input_class = '';
			if( $this->options[ 'vehicle_management_system' ]['keywords']['enable'] ){
				wp_enqueue_script( 'cdp_inventory_typeahead_js' , self::$plugin_information[ 'PluginURL' ] . '/application/assets/js/jquery-typeahead/typeahead.js' , array( 'jquery' ) , '0.11.1' );
				wp_register_script( 'cdp_inventory_general_js' , self::$plugin_information[ 'PluginURL' ] . '/application/assets/js/inventory/general.js' , array( 'jquery' ) , self::$plugin_information['Version'], true );
				$typeahead_keywords = explode(',', $this->options[ 'vehicle_management_system' ]['keywords']['pot']);
				wp_localize_script( 'cdp_inventory_general_js', 'cdp_keywords', $typeahead_keywords );
				wp_enqueue_script('cdp_inventory_general_js');
				$search_input_class = 'search-typeahead';
			}

			if( function_exists('gravity_form_enqueue_scripts') ){
				if( $this->options['vehicle_management_system']['theme']['list_gform_id'] ){
					$gform_element = '<div style="display: none;" id="inventory-gform-id" form="'.$this->options['vehicle_management_system']['theme']['list_gform_id'].'"></div>';
					$gform_class = 'inventory_get_gform';
					gravity_form_enqueue_scripts($this->options['vehicle_management_system']['theme']['list_gform_id'], true);
				}
			}
		break;
	}

	$inventory_style_url = self::$plugin_information['PluginURL'].'/application/assets/css/inventory/'.$current_theme.'.css';
	$inventory_style_url = apply_filters('cdp_inventory_style_url',$inventory_style_url);
	$inventory_script_url = self::$plugin_information['PluginURL'].'/application/assets/js/inventory/'.$current_theme.'.js';
	$inventory_script_url = apply_filters('cdp_inventory_script_url',$inventory_script_url);

	wp_enqueue_style( 'cdp_inventory', $inventory_style_url, array(), \cdp_theme_extender::$functions->get_extended_theme_version() );
	wp_register_script( 'cdp_inventory_js', $inventory_script_url, $dependent_scripts, \cdp_theme_extender::$functions->get_extended_theme_version(), TRUE );
	wp_localize_script( 'cdp_inventory_js', 'ajax_path', array($ajax_script) );
	wp_enqueue_script( 'cdp_inventory_js' );

	if( $page == 'detail' ){
		$db_caller = cdp_plugin::$db_caller; /*Deprecated*/
		$vin = (isset($this->parameters['vin'])? array('vin'=>$this->parameters['vin']): array());
		$vehicles = ( $vin ?cdp_plugin::$db_caller->cdp_db_init('inventory', $vin): array() );

		$this->parameters['saleclass'] = ( isset($vehicles[0])? $vehicles[0]['saleclass']: 'all');
		$this->parameters['vehicleclass'] = ( isset($vehicles[0])? $vehicles[0]['vehicleclass']: '');
		$this->parameters['dealer'] = ( isset($vehicles[0])? $vehicles[0]['dealer']: '');
		$this->parameters['dealer_id'] = ( isset($vehicles[0])? $vehicles[0]['dealer_id']: '');

		wp_register_script( 'cdp_inventory_calc_js', self::$plugin_information['PluginURL'].'/application/assets/js/loan-calculator.js', 'jquery', self::$plugin_information['Version'], TRUE );
		if( $this->parameters['saleclass'] == 'all'){
			$days_to_first_payment = 0;
		} else {
			$days_to_first_payment = isset($this->options['vehicle_management_system']['theme']['loan'][lcfirst($this->parameters['saleclass'])]['default']['days_to_payment']) ? $this->options['vehicle_management_system']['theme']['loan'][lcfirst($this->parameters['saleclass'])]['default']['days_to_payment']: 0;
		}
		wp_localize_script( 'cdp_inventory_calc_js', 'days_to_first', array($days_to_first_payment) );
		wp_enqueue_script( 'cdp_inventory_calc_js' );

		if( isset($vehicles[0]) && !empty($vehicles[0]) ){
			if( $this->options['vehicle_management_system']['social']['facebook']['enable'] ){
				if( $vehicles[0]['saleclass'] ==  'used' && $vehicles[0]['certified'] ){
					$fb_saleclass = 'Certified Pre-Owned';
				} else if( $vehicles[0]['saleclass'] ==  'used' ){
					$fb_saleclass = 'Pre-Owned';
				} else {
					$fb_saleclass = 'New';
				}
				$this->fb_title = $fb_saleclass.' '.$vehicles[0]['year'].' '.$vehicles[0]['make'].' '.$vehicles[0]['model'].' '.$vehicles[0]['trim'];
				$wp_head_args = array(
					'url'=> $this->page_url,
					'fb_title'=> $this->fb_title,
					'fb_desc'=> $this->fb_title.' from '.self::$db_company[0]['name'] .' in '.self::$db_company[0]['city'] .', '.self::$db_company[0]['state'],
					'fb_image'=> get_photo_list_display( $vehicles[0]['thumbnail'] )
				);
				add_action( 'wp_head' , function() use ($wp_head_args) {
						echo '<meta property="og:url" content="'.$wp_head_args['url'].'" />'. "\n";
						echo '<meta property="og:type" content="website" />'. "\n";
						echo '<meta property="og:title" content="'.$wp_head_args['fb_title'].'" />'. "\n";
						echo '<meta property="og:description" content="'.$wp_head_args['fb_desc'].'" />'. "\n";
						echo '<meta property="og:image" content="'.$wp_head_args['fb_image'].'" />'. "\n";
					}
				);
			}
		}
	}

	if( $this->options['vehicle_management_system']['scripts']['data'] ){
		cdp_apply_setting_scripts( $this->options[ 'vehicle_management_system' ]['scripts']['data'] ,$page, $this->parameters['saleclass'] );
	}
	if( $this->options['vehicle_management_system']['styles']['data'] ){
		cdp_apply_setting_styles( $this->options[ 'vehicle_management_system' ]['styles']['data'] ,$page, $this->parameters['saleclass'] );
	}

	get_header();
	flush();


	echo "\n".'<!--'.'[CDP Version] => '.self::$plugin_information['Version'].'-->'."\n";
	echo '<div id="cardealerpress-inventory" class="'.$current_theme.'-theme-wrapper db-version" theme="'.$current_theme.'" saleclass="'.(isset($vehicles[0])? ucfirst($vehicles[0]['saleclass']): $this->parameters['saleclass']).'" >';
		/*********
		Header Banner Add
		*********/
		$banners = $this->options['vehicle_management_system']['banners'];
		if( !empty($banners) ){
			echo '<div id="cdp-banner-top-container">';
			echo cdp_get_banners($page, 'top', $banners, $this->parameters );
			echo '</div>';
		}
		/*********
		Gravity Form Add
		*********/
		echo !empty($gform_element) ? $gform_element: '';
		/*********
		Facebook SDK
		*********/
		if( $this->options['vehicle_management_system']['social']['facebook']['enable'] ){
		?>
			<div id="fb-root"></div>
			<script>(function(d, s, id) {
			  var js, fjs = d.getElementsByTagName(s)[0];
			  if (d.getElementById(id)) return;
			  js = d.createElement(s); js.id = id;
			  js.src = 'https://connect.facebook.net/en_US/sdk.js#xfbml=1&version=v2.11';
			  fjs.parentNode.insertBefore(js, fjs);
			}(document, 'script', 'facebook-jssdk'));</script>
		<?php
		}

		/*********
		Inventory Content
		*********/
		include( $theme_path . '/' . $page . '.php' );
		/*********
		Footer Banner Add
		*********/
		if( !empty($banners) ){
			echo '<div id="cdp-banner-bottom-container">';
			echo cdp_get_banners($page, 'bottom', $banners, $this->parameters );
			echo '</div>';
		}
	echo '</div>';


	if( isset($this->options['vehicle_management_system']['scripts']['inject'][$page]) && !empty($this->options['vehicle_management_system']['scripts']['inject'][$page]) ){
		echo "\r\n".'<div id="cdp-inventory-injected-script-'.$page.'">'."\r\n";
			$scriptData = urldecode(stripslashes($this->options['vehicle_management_system']['scripts']['inject'][$page]));
			if( $page == 'detail' ){
				$scriptData = str_replace('[VIN]', $vehicle['vin'], $scriptData);
				$scriptData = str_replace('[STOCK]', $vehicle['stock'], $scriptData);
			}
			echo $scriptData;
		echo "\r\n".'</div>'."\r\n";
	}

	if( isset($this->options['vehicle_management_system']['styles']['inject']) && !empty($this->options['vehicle_management_system']['styles']['inject']) ){
		echo "\r\n".'<div id="cdp-inventory-injected-style-'.$page.'">'."\r\n";
			echo '<style type="text/css">'.urldecode(stripslashes($this->options['vehicle_management_system']['styles']['inject'])).'</style>';
		echo "\r\n".'</div>'."\r\n";
	}

	if( $this->options[ 'alt_settings' ][ 'debug_plugin_info' ] ){
		echo "\n" . '<!--' . "\n";
		echo '########' . "\n";
		if( isset($this->seo_headers->request_stack[1]) && !empty($this->seo_headers->request_stack[1]) ){
			echo '[SEO Helper] => ' . $this->seo_headers->request_stack[1] ."\n";
		}
		echo print_r( $this->company , true ) . "\n";
		echo print_r( $this->vms , true ) . "\n";
		echo "\n" . '########' . "\n";
		echo '-->' . "\n";
	}

	flush();
	get_footer();
?>
