<?php
namespace Wordpress\Plugins\CarDealerPress\Inventory\Api;

	$this->load_admin_assets();
	$this->get_admin_header();
?>

<div id="cdp-content-wrapper">
	<div id="cdp-content-wrapper-advanced" class="advanced-wrapper hide">
		<div id="company-settings-advanced" class="tr-wrapper">
			<div class="td-full"><h3 class="title">Company Settings</h3></div>
		</div>
		<div class="tr-wrapper tr-color">
			<div class="td-full center center-flex">
				<div id="cdp-default-settings" class="">Default Settings</div>
			</div>
		</div>
		<div class="tr-wrapper tr-color">
			<div class="td-full center center-flex">
				<h3 style="color: #FF0000;" class="">Any Changes Need Inventory Manually Refreshed.</h3>
			</div>
		</div>
		<div id="add-additonal-dealer-row" class="tr-wrapper tr-color">
			<div class="td-full center">
				<div class=""><h3 class="center-title">Add Additional Dealer(s)</h3></div>
			</div>
			<div class="td-two right">
				<input type="text" name="dealer" id="company-id-advanced"  value="" class="input-short" />
			</div>
			<div class="td-two left"><span id="add-dealer-button-advanced" class="td-button">Add Dealer</span></div>
			<div class="td-full-small center"><small class="full-small">Add additonal dealers to import multiple feeds.</small></div>
			<div class="td-full-small center"><p id="dealer-ajax-message-advanced" class="data-ajax-message"></p></div>
		</div>
		<div class="tr-wrapper tr-color">
			<div class="td-full center">
				<div id="default-add-title"><h3 class="center-title">Add Custom Import</h3></div>
			</div>
			<div class="td-full center">
				<div id="import-update-id" value="" name="update_id"></div>
			</div>
			<div class="td-full td-three-flex">
				<div class="td-import-text">Dealer ID</div>
				<div class="td-import-input">
					<select id="import-dealer-select" class="import-input-value" name="dealer">
						<option value="0">Select Dealer</option>
						<?php
							foreach( $this->companyDB as $key=>$value ){
								echo '<option value="'.$value['dealer_id'].'">'.$value['dealer_id'].'</option>';
							}
						?>
					</select>
				</div>
				<div class="td-import-symbol">
				</div>
			</div>
			<div class="td-full td-three-flex">
				<div class="td-import-text">Saleclass</div>
				<div class="td-import-input">
					<select id="import-saleclass-select" class="import-input-value" name="saleclass">
						<option value="">All</option>
						<option value="new">New</option>
						<option value="used">Used</option>
						<option value="certified">Certified</option>
					</select>
				</div>
				<div class="td-import-symbol">
				</div>
			</div>
			<div class="td-full td-three-flex">
				<div class="td-import-text">Make</div>
				<div class="td-import-input">
					<input id="import-make-input" type="text" name="make" class="import-input-value" value="" placeholder="Ford,Dodge,Chevrolet" />
				</div>
				<div class="td-import-symbol">
					<select id="import-make-symbol" class="import-input-value" name="symbol">
						<option value="0">Equal (=)</option>
						<option value="1">Not Equal (!=)</option>
					</select>
				</div>
			</div>
			<div class="td-full td-three-flex">
				<div class="td-import-text">Year</div>
				<div class="td-import-input">
					<input type="text" name="year" id="import-year-input" class="import-input-value" value="" placeholder="1999,2000,2001" />
				</div>
				<div class="td-import-symbol">
					<select id="import-year-symbol" class="import-input-value" name="symbol">
						<option value="0">Equal (=)</option>
						<option value="2">Greater Than (>)</option>
						<option value="3">Less Than (<)</option>
					</select>
				</div>
				<div class="td-full-small center"><p class="notification"><sup>*</sup>Only one year can be entered when using Great Than or Less Than.</p></div>
			</div>
			<div class="td-full center"><span id="add-custom-import" class="td-button-import">Add Custom Import</span></div>
			<div class="td-full-small center"><p id="import-ajax-message" class="data-ajax-message"></p></div>
		</div>
		<div id="current-import-dealer-wrapper" class="tr-wrapper tr-color">
			<div class="td-full center">
				<div class=""><h3 class="center-title">Current Dealer(s) / Import(s)</h3></div>
			</div>
			<?php
				foreach( $this->companyDB as $key=>$dealer ){
					echo admin_get_custom_dealers($dealer);
				}
			?>
		</div>
	</div>

	<div id="cdp-content-wrapper-default" class="settings-wrapper display">
		<div id="company-settings-default" class="tr-wrapper">
			<div class="td-full"><h3 class="title">Company Settings</h3></div>
		</div>
		<?php if( class_exists('cdp_theme_extender') ){ ?>
		<div class="tr-wrapper tr-color">
			<div class="td-full center center-flex">
				<div id="cdp-import-advanced" class="">Advanced Settings</div>
			</div>
		</div>
		<?php }
		$company_id = $this->options['vehicle_management_system']['company_information']['id'];
		?>
		<div class="tr-wrapper tr-color">
			<div class="td-two center"><span class="td-title">Company ID:</span></div>
			<div class="td-two">
				<?php
					$company_class = empty($company_id)? 'cdp-input': '';
				?>
				<input type="text" name="vehicle_management_system/company_information/id" id="company-id" extra="refresh" value="<?php echo $company_id; ?>" class="input-short <?php echo $company_class;?>" />
			</div>
			<div class="td-full center">
				<?php if( $company_id ){ ?>
				<div id="cdp-change-company-buttons">
					<div id="change-only-company" name="vehicle_management_system/company_information/id">Change Company ID</div>
					<div id="change-clear-company" name="vehicle_management_system/company_information/id">Change Company ID and Clear</div>
				</div>
				<?php } ?>
				<?php
				if( class_exists('cdp_theme_extender') ){
					if( $this->companyDB ){
						$company_last_update = $this->companyDB[0]['last_updated'];
						echo '<div><small style="font-weight: bold;">Company Last Updated: '.wp_date( 'm-d-Y H:i',$company_last_update ) .'</small></div>';
					}
				}
				?>
				<small>Inventory will not be retreived without providing a valid company ID.</small>
			</div>
		</div>
		<div class="tr-wrapper tr-color">
			<div class="td-two center"><span class="td-title">Blog ID:</span></div>
			<div class="td-two">
				<div name="blog_id" id="blog-id" class="input-short"><?php echo get_current_blog_id(); ?></div>
			</div>
		</div>
		<div class="tr-wrapper tr-color">
			<div class="td-two center"><span class="td-title">Blog Inventory Table:</span></div>
			<div class="td-two">
				<div name="blog_id" id="blog-id" class="input-short"><?php echo 'cdp_inventory_'.get_current_blog_id(); ?></div>
			</div>
		</div>
		<?php
		if( !empty($this->options[ 'vehicle_management_system' ][ 'company_information' ][ 'id' ]) ){
		?>

		<div class="tr-wrapper tr-color">
			<div class="td-two center"><span class="td-title">Disable Search Engine Visibility:</span></div>
			<div class="td-two">
				<input type="checkbox" id="discourage_seo_visibility" name="alt_settings/discourage_seo_visibility" <?php if ( $this->options[ 'alt_settings' ][ 'discourage_seo_visibility' ] != '' ) { echo 'checked'; } ?> class="cdp-input" />
			</div>
			<div class="td-full center"><small>Discourage search engines from indexing inventory pages</small></div>
		</div>
		<div class="tr-wrapper tr-color">
			<div class="td-two center"><span class="td-title">Show Plugin Debug Info:</span></div>
			<div class="td-two">
				<input type="checkbox" id="discourage_seo_visibility" name="alt_settings/debug_plugin_info" <?php if ( $this->options[ 'alt_settings' ][ 'debug_plugin_info' ] != '' ) { echo 'checked'; } ?> class="cdp-input" />
			</div>
			<div class="td-full center"><small>Shows current plugin settings "commented out" on front end to help debug issues.</small></div>
		</div>
		<!--<div class="tr-wrapper tr-color">
			<div class="td-two center"><span class="td-title">Add Access Control to header:</span></div>
			<div class="td-two">
				<input type="text" id="domain_access_control" name="alt_settings/domain_access_control" value="<?php //echo $this->options[ 'alt_settings' ][ 'domain_access_control' ]; ?>" class="cdp-input" />
			</div>
			<div class="td-full center"><small>Adds access control to header for multisites domain mapping.</small></div>
		</div>-->

		<?php
			if( class_exists('cdp_theme_extender') ){
		?>
			<div class="tr-wrapper tr-color">
				<div class="td-two center"><span class="td-title">Refresh Dealer Info:</span></div>
				<div class="td-two">
					<div id="manually-run-company-job" name="dealerRefresh" class="cdp-run-input">Manually Refresh Dealer</div>
				</div>
				<div class="td-full center"><small></small></div>
			</div>
			<div class="tr-wrapper tr-color">
				<div class="td-two center"><span class="td-title">Run Inventory Import:</span></div>
				<div class="td-two">
					<div id="manually-run-import-job" class="cdp-run-input">Manually Import All Inventory</div>
				</div>
				<div id="manually-run-import-job-confirm" class="td-full center">
					<p>This will delete all inventory from this <b>Blog</b>. If multiple dealers are assigned to this blog, it’s recommended to only manually update the dealer(s) which need to be updated. If you wish to continue, please click confirm to initiate the full re-import.</p>
					<div id="manually-run-import-confirm-buttons">
						<div id="confirm-full-manual-run">Confirm</div>
						<div id="decline-full-manual-run">Close</div>
					</div>
				</div>
			</div>
			<div class="tr-wrapper tr-color">
				<div class="td-full center center-flex">
					<div id="cdp-import-status" class="">Import Status</div>
				</div>
				<div id="cdp-import-status-display" class="td-full active-display">
				<?php
					$content = '';
					if( $this->companyDB ){
						foreach( $this->companyDB as $dealer ){
							$content .= '<div class="import-inner-td-full">';
								$content .= '<div class="import-dealer-headline">';
									$content .= '<div class="import-dealer-id">VMS ID: '.$dealer['dealer_id'].'</div>';
									$content .= '<div class="import-dealer-name">'.$dealer['name'].'</div>';
								$content .= '</div>';
								$content .= '<div class="import-dealer-content">';
									$content .= '<div class="import-dealer-vehicle-counts">';
										$content .= '<div class="import-dealer-new-count">New Vehicles: <span>'.cdp_plugin::$db_caller->cdp_db_init('searchtotal',array('saleclass'=>'new','dealer_id'=>$dealer['dealer_id']) ).'</span></div>';
										$content .= '<div class="import-dealer-used-count">Used Vehicles: <span>'.cdp_plugin::$db_caller->cdp_db_init('searchtotal',array('saleclass'=>'used','dealer_id'=>$dealer['dealer_id']) ).'</span></div>';
										$content .= '<div class="import-dealer-total-count">Total Vehicles: <span>'.cdp_plugin::$db_caller->cdp_db_init('searchtotal',array('dealer_id'=>$dealer['dealer_id']) ).'</span></div>';
									$content .= '</div>';
									$content .= '<div class="import-dealer-data">';
										$content .= '<span class="cdp-run-input dealer-run" name="runDealerImport" dealer="'.$dealer['dealer_id'].'">Manually Import</br>Dealer Inventory</span>';
                                        if( empty($dealer['automalls']) ) {
                                            $time_diff = time() - $dealer['inventory_api_last_modified'];
                                            $content .= '<span>Inventory Stats:</span>';
                                            $content .= '<ul style="list-style-type: none;margin:0;">';
                                            $content .= '<li style="margin: 0;">API Last Modified: <small style="font-weight: bold;">' . wp_date('m-d-Y H:i', $dealer['inventory_api_last_modified']) . ' </small>';
                                            $content .= '<small style="font-size: 10px;"> ( ' . cdp_time_elapsed($time_diff) . ' ago)</small></li>';
                                            $last_updated_diff = time() - $dealer['inventory_last_updated'];
                                            $content .= '<li style="margin: 0;">Site Last Updated: <small style="font-weight: bold;"> ' . wp_date('m-d-Y H:i', $dealer['inventory_last_updated']) . '</small>';
                                            $content .= '<small style="font-size: 10px;"> ( ' . cdp_time_elapsed($last_updated_diff) . ' ago)</small></li>';
                                            $content .= '<li style="margin: 0;">Last Checked API: <small style="font-weight: bold;">' . wp_date('m-d-Y H:i', $dealer['inventory_last_checked']) . '</small></li>';
                                            $content .= '</ul>';
                                        } else {
                                            $content .= '<span>Company is an automall, does not contain its own inventory</span>';
                                        }
                                    $content .= '</div>';
								$content .= '</div>';
							$content .= '</div>';
						}
					}
					echo $content;
				?>
				</div>
			</div>
		<?php
			}
		}
		?>

	</div>
</div>



<?php
	function cdp_time_elapsed($secs){
    	$bit = array(
        	'y' => $secs / 31556926 % 12,
        	'w' => $secs / 604800 % 52,
        	'd' => $secs / 86400 % 7,
        	'h' => $secs / 3600 % 24,
        	'm' => $secs / 60 % 60
        );

        foreach($bit as $k => $v) {
            if ($v > 0) $ret[] = $v . $k;
        }
        if ( empty($ret) ) { return 'less than a minute ago'; }
    	return join(' ', $ret);
    }

	$this->admin_footer();
?>
