<?php
namespace Wordpress\Plugins\CarDealerPress\Inventory\Api;
?>

	<div id="view-SortWrapper" class="view-wrapper">
		<div class="tr-wrapper">
			<div class="td-full">
				<h4 class="divider">Sort Settings</h4>
			</div>
		</div>
		
		<div class="tr-wrapper tr-color wrapper">
			<div id="sortCreateDefault" class="inner-table-content">
				<div class="inner-td-full">
					<h5>Default Sort Filter</h5>
				</div>
				<div class="inner-td-content">
					<?php $defaultSort = $this->options['vehicle_management_system']['sort']['default']; ?>
					<select name="vehicle_management_system/sort/default" class="cdp-input">
						<option value="makeModel" <?php if ( $defaultSort == 'makeModel' ) { echo 'selected'; } ?> ><?php _e('Make/Model A -> Z'); ?></option>
						<option value="createdA" <?php if ( $defaultSort == 'createdA' ) { echo 'selected'; } ?> ><?php _e('Created Date Low -> High'); ?></option>
						<option value="createdD" <?php if ( $defaultSort == 'createdD' ) { echo 'selected'; } ?> ><?php _e('Created Date High -> Low'); ?></option>
						<option value="yearA" <?php if ( $defaultSort == 'yearA' ) { echo 'selected'; } ?> ><?php _e('Year Low -> High'); ?></option>
						<option value="yearD" <?php if ( $defaultSort == 'yearD' ) { echo 'selected'; } ?> ><?php _e('Year High -> Low'); ?></option>
						<option value="priceA" <?php if ( $defaultSort == 'priceA' ) { echo 'selected'; } ?> ><?php _e('Price Low -> High'); ?></option>
						<option value="priceD" <?php if ( $defaultSort == 'priceD' ) { echo 'selected'; } ?> ><?php _e('Price High -> Low'); ?></option>
					</select>
				</div>
			</div>
			
		</div>
		
		<div class="tr-wrapper tr-color wrapper">
			<div id="sortCreate" class="inner-table-content">
				<div class="inner-td-full">
					<h5>Create/Apply Sort Filter</h5>
				</div>
				<div class="inner-td-content-full">
					<?php
					$content = ''; $makes = $models = $years = $vehicleclass = $tags = $dealers = array();
					$makes = cdp_plugin::$db_caller->cdp_db_init('make', array('pass'=>'1'));
					$models = cdp_plugin::$db_caller->cdp_db_init('model', array('pass'=>'1'));
					$years = cdp_plugin::$db_caller->cdp_db_init('year', array('pass'=>'1'));
					$vehicleclass = cdp_plugin::$db_caller->cdp_db_init('vehicleclass', array('pass'=>'1'));
					$tags = cdp_plugin::$db_caller->cdp_db_init('tags', array('pass'=>'1'));
					$dealers = cdp_plugin::$db_caller->cdp_db_init('dealers', array('pass'=>'1'));
					//Sale Class
					$content .= '<div class="inner-row-wrap"><label>Sale Class</label><select class="init-admin-db admin-db-filter admin-db-sort-value" tag="saleclass">';
						$content .= '<option value="all">All</option>';
						$content .= '<option value="new">New</option>';
						$content .= '<option value="used">Used</option>';
						$content .= '<option value="cert">Certified</option>';
					$content .= '</select></div>';
					//Makes
					if( $makes ){
						$content .= '<div class="inner-row-wrap"><label>Make</label><select class="init-admin-db admin-db-filter admin-db-sort-value" tag="make">';
							$content .= '<option value="">Select a Make</option>';
							foreach( $makes as $make ){
								$content .= '<option value="'.$make['Make'].'">'.$make['Make'].'</option>';
							}
						$content .= '</select></div>';
					}
					//Models
					if( $models ){
						$content .= '<div class="inner-row-wrap"><label>Model</label><select class="init-admin-db admin-db-filter admin-db-sort-value" tag="model">';
							$content .= '<option value="">Select a Model</option>';
							foreach( $models as $model ){
								$content .= '<option value="'.$model['Model'].'">'.$model['Model'].'</option>';
							}
						$content .= '</select></div>';
					}
					//Years
					if( $years ){
						$content .= '<div class="inner-row-wrap"><label>Year</label><select class="init-admin-db admin-db-filter admin-db-sort-value" tag="year">';
							$content .= '<option value="">Select a Year</option>';
							foreach( $years as $year ){
								$content .= '<option value="'.$year['Year'].'">'.$year['Year'].'</option>';
							}
						$content .= '</select></div>';
					}
					//Vehicle Class
					if( $vehicleclass ){
						$content .= '<div class="inner-row-wrap"><label>Class</label><select class="init-admin-db admin-db-filter admin-db-sort-value" tag="vehicleclass">';
							$content .= '<option value="">Select a Vehicle Class</option>';
							foreach( $vehicleclass as $class ){
								$content .= '<option value="'.$class['Vehicleclass'].'">'.$class['Vehicleclass'].'</option>';
							}
						$content .= '</select></div>';
					}
					//Tags
					if( $tags ){
						$content .= '<div class="inner-row-wrap"><label>Tag</label><select class="init-admin-db admin-db-filter admin-db-sort-value" tag="tags">';
							$content .= '<option value="">Select a Tag</option>';
							foreach( $tags as $tag ){
								if( $tag ){
									$content .= '<option value="'.$tag.'">'.$tag.'</option>';	
								}
							}
						$content .= '</select></div>';
					}
					//Dealers
					if( $dealers && count($dealers) > 1 ){
						$content .= '<div class="inner-row-wrap"><label>Dealer</label><select class="init-admin-db admin-db-filter admin-db-sort-value" tag="dealer">';
							$content .= '<option value="">Select a Dealer</option>';
							foreach( $dealers as $dealer ){
								$content .= '<option value="'.$dealer['Dealer'].'">'.$dealer['Dealer'].'</option>';
							}
						$content .= '</select></div>';
					}
					
					echo $content;
					?>
					<div class="inner-row-wrap">
						<label>Sort Value</label>
						<input type="number" tag="sort" class="admin-db-sort-value input-short required" value="0"/>
					</div>
					<div class="inner-row-wrap">
						<label>Name</label>
						<input type="text" tag="name" class="admin-db-sort-value input-long required" value=""/>
					</div>
					<div class="inner-row-wrap">
						<div class="current-sort-count-value">Found: <span>0</span></div>
					</div>
					<div class="admin-init-options">
						<div class="sort-save init-ajax-save-sort" tag='sort' name='vehicle_management_system/sort/data[]'>Save/Apply</div>
					</div>
				</div>
			</div>
			
		</div>
		
		<!--<button class="add-row-button sort-row-button" tag="sortRows">Add/Apply Sort Filter</button>-->
		
		<div class="tr-wrapper tr-color wrapper">
			<div id="sortRows" class="inner-table-content">
				<div class="inner-td-full">
					<h5>Current Custom Filters</h5>
				</div>
				<?php
				//error_log(print_r($this->options['vehicle_management_system']['sort']['data'], TRUE));
				$rows = get_sort_rows( $this->options['vehicle_management_system']['sort']['data'] );
				echo $rows;
				?>
			</div>
		</div>
	</div>