<?php
namespace Wordpress\Plugins\CarDealerPress\Inventory\Api;

	$rules = get_option( 'rewrite_rules' );
	$url_rule = ( isset($rules['^(inventory)']) ) ? TRUE : FALSE;

	$state = $this->company->state;
	$city = $this->company->city;

	$site_url = site_url();
	
	$rawMakes = cdp_plugin::$db_caller->cdp_db_init( 'make', array('saleclass'=>$this->sc_atts['saleclass']) );
	
	if( empty($this->sc_atts['make']) ){
		$makes = $rawMakes;
	} else {
		foreach( $rawMakes as $key=>$makeData ){
			if( $makeData['Make'] == $this->sc_atts['make'] ){
				$makes[] = $rawMakes[$key];
			}
		}
	}

	$sc_content = '<div id="sc-inventory-counter-'.strtolower($this->sc_atts['saleclass']).'" class="counter-container" >';

	if( empty($makes) ) {
		$sc_content .= '<div class="sc-count-not-found"><h2><strong>No count inventory found. Double check shortcode settings.</strong></h2></div>';
	} else {
		foreach( $makes as $key=>$makeData ){
			$link = generate_inventory_link($url_rule,array('saleclass'=>ucfirst($this->sc_atts['saleclass']),'make'=>$makeData['Make']));
			$sc_content .= '<div class="counter-wrapper '.$makeData['Make'].' '.strtolower($this->sc_atts['saleclass']).'">';
				$sc_content .= '<div class="make-label"><a href="'.$link.'"><span class="make-name">'.$makeData['Make'].'</span>'.( !empty($this->sc_atts['show_make_count'])? ' <span class="make-count">('.$makeData['Total'].')</span>': '' ).'</a></div>';
				if( $this->sc_atts['show_models'] || $this->sc_atts['model'] ){
					$rawModels = cdp_plugin::$db_caller->cdp_db_init( 'model', array('saleclass'=>$this->sc_atts['saleclass'],'make'=>$makeData['Make']) );
					if( empty($this->sc_atts['model']) ){
						$models = $rawModels;
					} else {
						foreach( $rawModels as $key=>$modelData ){
							if( $modelData['Model'] == $this->sc_atts['model'] ){
								$models[] = $rawModels[$key];
							}
						}
					}
					foreach( $models as $key=>$modelData ){
						$link = generate_inventory_link($url_rule,array('saleclass'=>ucfirst($this->sc_atts['saleclass']),'make'=>$makeData['Make'],'model'=>$modelData['Model']));
						$sc_content .= '<div class="model-label '.$modelData['Model'].'"><a href="'.$link.'"><span class="model-name">'.$modelData['Model'].'</span>'.( $this->sc_atts['show_model_count']? ' <span class="model-count">('.$modelData['Total'].')</span>': '' ).'</a></div>';
					}
					if( $this->sc_atts['model'] ){
						$trims = cdp_plugin::$db_caller->cdp_db_init( 'trim', array('saleclass'=>$this->sc_atts['saleclass'],'make'=>$makeData['Make'], 'model'=>$this->sc_atts['model']) );
						foreach( $trims as $key=>$trimData ){
							$link = generate_inventory_link($url_rule,array('saleclass'=>ucfirst($this->sc_atts['saleclass']),'make'=>$makeData['Make'],'model'=>$modelData['Model'], 'trim'=>rawurlencode($trimData['Trim'])));
							$sc_content .= '<div class="trim-label '.$trimData['Trim'].'"><a href="'.$link.'"><span class="trim-name">'.$trimData['Trim'].'</span>'.( $this->sc_atts['show_model_count']? ' <span class="trim-count">('.$trimData['Total'].')</span>': '' ).'</a></div>';
						}
					}
				}
			$sc_content .= '</div>';
		}
		
	}

	$sc_content .= '</div>';
	$this->sc_content = $sc_content;

?>
