<?php
namespace Wordpress\Plugins\CarDealerPress\Inventory\Api;

	$plugin_url = plugins_url('/cardealerpress');

	switch($this->taxonomy){
		case 'new-vehicle-sitemap':
			$type = 'new';
			break;
		case 'used-vehicle-sitemap':
			$type = 'used';
			break;
		case 'video-vehicle-sitemap':
			$type = 'video';
			break;
	}

	$siteMap_array = array();
	$sitemap_output = '';
	$date_raw = wp_date("Y-m-d H:i P", strtotime('-1 day', strtotime( wp_date("Y-m-d H:i P", time())) ) );
	$utc_timezone = new \DateTimeZone( 'UTC' );
	$datetime = new \DateTime( $date_raw, $utc_timezone );
	$last_mod = $datetime->format('c');

	if( $type != 'video' ){
		//init
		array_push( $siteMap_array, array( home_url( '/inventory/'.ucfirst($type).'/' ), '.9' ) );
		//VehicleClass
		$siteMap_DBdata = cdp_plugin::$db_caller->cdp_inventory_special_request('saleclass,vehicleclass',' saleclass="'.$type.'"');
		if($siteMap_DBdata){
			foreach($siteMap_DBdata as $key=>$data){
				array_push( $siteMap_array, array( home_url( '/inventory/'.ucfirst($type).'/?vehicleclass='.rawurlencode($data['vehicleclass']) ), '.8' ) );
			}
		}
		//Make
		$siteMap_DBdata = cdp_plugin::$db_caller->cdp_inventory_special_request('saleclass,make',' saleclass="'.$type.'"');
		if($siteMap_DBdata){
			foreach($siteMap_DBdata as $key=>$data){
				array_push( $siteMap_array, array( home_url( '/inventory/'.ucfirst($type).'/'.rawurlencode($data['make']).'/' ), '.8' ) );
			}
		}
		//Certified if Available
		if( $type == 'used' ){
			$siteMap_DBdata = cdp_plugin::$db_caller->cdp_inventory_special_request('make',' saleclass="'.$type.'" and certified=1 ');
			if($siteMap_DBdata){
				foreach($siteMap_DBdata as $key=>$data){
					array_push( $siteMap_array, array( home_url( '/inventory/'.ucfirst($type).'/'.rawurlencode($data['make']).'/?certified=Yes' ), '.8' ) );
				}
			}
		}
		//Model
		$siteMap_DBdata = cdp_plugin::$db_caller->cdp_inventory_special_request('saleclass,make,model',' saleclass="'.$type.'"');
		if($siteMap_DBdata){
			foreach($siteMap_DBdata as $key=>$data){
				array_push( $siteMap_array, array( home_url( '/inventory/'.ucfirst($type).'/'.rawurlencode($data['make']).'/'.rawurlencode($data['model']).'/' ), '.7' ) );
			}
		}
		//Trim
		$siteMap_DBdata = cdp_plugin::$db_caller->cdp_inventory_special_request('saleclass,make,model,trim',' saleclass="'.$type.'"');
		if($siteMap_DBdata){
			foreach($siteMap_DBdata as $key=>$data){
				array_push( $siteMap_array, array( home_url( '/inventory/'.ucfirst($type).'/'. rawurlencode($data['make']) .'/'. rawurlencode($data['model']) .'/?trim='.rawurlencode($data['trim']) ), '.7' ) );
			}
		}
		//Vehicle Detail
		$siteMap_DBdata = cdp_plugin::$db_caller->cdp_inventory_special_request('',' saleclass="'.$type.'"');
		if($siteMap_DBdata){
			foreach($siteMap_DBdata as $key=>$data){
				array_push( $siteMap_array, array( home_url( '/inventory/'.$data['year'].'/'. rawurlencode($data['make']) .'/'. rawurlencode($data['model']) .'/'. rawurlencode($data['geo_state']) .'/'. rawurlencode($data['geo_city']) .'/'. rawurlencode($data['vin']) ), '.7', $data['updated'] ) );
			}
		}
		//error_log(print_r($siteMap_array,true));

		if( $siteMap_array ){
			foreach( $siteMap_array as $data ){
				if( isset($data[2]) ){
					$vehicleUpdated = new \DateTime( $data[2], $utc_timezone );
					$vehicleMod = $vehicleUpdated->format('c');
				} else {
					$vehicleMod = $last_mod;
				}
				$value = '<url>' . "\n";
				$value .= '<loc>' . $data[0] . '</loc>' . "\n";
				$value .= '<lastmod>' . htmlspecialchars($vehicleMod) . '</lastmod>' . "\n";
				$value .= '<changefreq>daily</changefreq>' . "\n";
				$value .= '<priority>' . $data[1] . '</priority>' . "\n";
				$value .= '</url>' . "\n";

				$sitemap_output .= $value;
			}
			display_output( $sitemap_output, $plugin_url );
		}
	} else {
		$siteMap_DBdata = cdp_plugin::$db_caller->cdp_inventory_special_request('', 'video<>""');
		if($siteMap_DBdata){
			foreach($siteMap_DBdata as $key=>$data){
				$value = '<url>' . "\n";

				$value .= '<loc>' . home_url( '/inventory/'.$data['year'].'/'. rawurlencode($data['make']) .'/'. rawurlencode($data['model']) .'/'. rawurlencode($data['geo_state']) .'/'. rawurlencode($data['geo_city']) .'/'. rawurlencode($data['vin']) ) . '</loc>' ."\n";

				$value .= '<video:video>'."\n";
				$title = ucfirst($data['saleclass']) .' '. $data['year'] .' '. $data['make'] .' '. $data['model'];
				$value .= '<video:thumbnail_loc>'. $data['thumbnail'] .'</video:thumbnail_loc>'."\n";
				$value .= '<video:title><![CDATA['. $title .']]></video:title>'."\n";
				$value .= '<video:description>'. ($data['description']? '<![CDATA['.cdp_limit_word_count(html_entity_decode($data['description']),50).']]>': $title .' '.$data['trim']) .'</video:description>'."\n";
				$value .= '<video:player_loc allow_embed="no"><![CDATA['. $data['video'] .']]></video:player_loc>'."\n";
				$value .= '</video:video>'."\n";

				$value .= '</url>' . "\n";

				$sitemap_output .= $value;
			}
			//error_log(print_r($sitemap_output,true));
			display_video( $sitemap_output, $plugin_url );
		}

	}


	function display_output( $output, $style_url ){
		//header( 'HTTP/1.0 200 OK', true, 200 );
		// Prevent the search engines from indexing the XML Sitemap.
		header( 'X-Robots-Tag: noindex, follow', true );
		header( 'Content-Type: text/xml' );
		header('Access-Control-Allow-Origin: *');
		echo '<?xml version="1.0" encoding="' . get_bloginfo( 'charset' ) . '"?>';
		$stylesheet = '<?xml-stylesheet type="text/xsl" href="' . $style_url . '/application/views/sitemap/inc/xml-sitemap-xsl.php"?>';
		echo $stylesheet . "\n";

		echo '<urlset xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ';
		echo 'xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 https://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd" ';
		echo 'xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">' . "\n";
		echo $output . "\n";
		echo '</urlset>';

	}

	function display_video( $output, $style_url ){
		header( 'X-Robots-Tag: noindex, follow', true );
		header( 'Content-Type: text/xml' );
		header('Access-Control-Allow-Origin: *');
		echo '<?xml version="1.0" encoding="' . get_bloginfo( 'charset' ) . '"?>';
		$stylesheet = '<?xml-stylesheet type="text/xsl" href="' . $style_url . '/application/views/sitemap/inc/xml-sitemap-video-xsl.php"?>';
		echo $stylesheet . "\n";

		echo '<urlset  xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" ';
        echo 'xmlns:video="http://www.google.com/schemas/sitemap-video/1.1">' . "\n";
		echo $output . "\n";
		echo '</urlset>';
	}

?>
