<?php

namespace Wordpress\Plugins\CarDealerPress\Inventory\Api;

require_once( dirname( __FILE__ ) . '/application/helpers/http_request.php' );
require_once( dirname( __FILE__ ) . '/application/helpers/multi_request.php' );
require_once( dirname( __FILE__ ) . '/application/helpers/vehicle_management_system.php' );
require_once( dirname( __FILE__ ) . '/application/helpers/dynamic_site_headers.php' );

require_once( dirname( __FILE__ ) . '/application/views/widgets/vms_search_box.php' );
require_once( dirname( __FILE__ ) . '/application/views/shortcode/sc_index.php' );

require_once( dirname( __FILE__ ) . '/application/functions/fn_inventory.php' );
require_once( dirname( __FILE__ ) . '/application/functions/db_requests.php' );
require_once( dirname( __FILE__ ) . '/application/functions/fn_views.php' );

class cdp_plugin {

	public $options = array(
		'vehicle_management_system' => array(
			'company_information' => array(
				'id' => 0
			),
			'host' => 'https://api.dealertrend.com',
			'theme' => array(
				'name' => 'armadillo',
				'per_page' => 10,
				'loan' => array(
					'used' => array(
						'default' => array(
							'display_calc' => '',
							'display_payment' => '',
							'display_monthly' => '',
							'display_bi_monthly' => '',
							'display_total_cost' => '',
							'interest' => '0',
							'trade' => '0',
							'term' => '0',
							'down' => '0',
							'tax' => '0',
							'disclaimer' => '',
							'display_text' => '',
							'down_percent' => '',
							'days_to_payment' => 0
						)
					),
					'new' => array(
						'default' => array(
							'display_calc' => '',
							'display_payment' => '',
							'display_monthly' => '',
							'display_bi_monthly' => '',
							'display_total_cost' => '',
							'interest' => '0',
							'trade' => '0',
							'term' => '0',
							'down' => '0',
							'tax' => '0',
							'disclaimer' => '',
							'display_text' => '',
							'down_percent' => '',
							'days_to_payment' => 0
						)
					),
					'custom' => array()
				),
				'forms' => array(),
				'emails' => array(
					'defaults' => array(
						'new' => '',
						'used'=> ''
					),
					'dealers' => array()
				),
				'price_text' => array(
					'new' => array('standard_price' => '', 'compare_price' => '', 'sale_price' => '', 'default_price' =>  ''),
					'used' => array('standard_price' => '', 'compare_price' => '', 'sale_price' => '', 'default_price' =>  '')
				),
				'show_standard_eq' => 0,
				'style' => array(
					'flex' => array(
						'toggle' => '',
						'settings' => array(
							'containers' => array(
								'one' => array( 'order' => 1, 'max-width' => 100),
								'two' => array( 'order' => 1, 'max-width' => 100),
								'three' => array( 'order' => 1, 'max-width' => 100),
								'four' => array( 'order' => 1, 'max-width' => 100),
								'five' => array( 'order' => 1, 'max-width' => 100),
								'six' => array( 'order' => 1, 'max-width' => 100)
							)
						)
					)
				),
				'display_geo' => '', // cdp
				'add_geo_zip' => '', // cdp
				'geo_display' => '',
				'geo_options' => '',
				'display_dealer_contact_name' => '',
				'display_dealer_contact_phone' => '',
				'display_dealer_contact_address' => '',
				'display_dealer_contact_city_state' => '',
				'display_tags' => '',
				'display_similar' => '',
				'display_bodystyle' => '',
				'display_drivetrain' => '',
				'display_mpg' => '',
				'display_transmission' => '',
				'default_image_tab' => '',
				'default_info_tab' => '',
				'list_info_button' => '',
				'list_form_button' => '',
				'list_gform_id' => '',
				'detail_gform_id' => '',
				'hide_saleclass' => '',
				'hide_features' => '',
				'hide_vehicleclass' => '',
				'hide_certified_saleclass' => '',
				'saved_vehicles' => array(
					'display' => '',
					'form' => ''
				)
			),
			'saleclass' => 'all',
			'data' => array(
				'makes_new' => array(),
				'default_no_image' => ''
			),
			'custom_contact' => array(
				'phone' => array('new'=>'','used'=>''),
				'contact_name' => array('new'=>'','used'=>''),
				'street' => array('new'=>'','used'=>''),
				'city' => array('new'=>'','used'=>''),
				'zip' => array('new'=>'','used'=>''),
				'breadcrumb' => ''
			),
			'tags' => array(
				'data' => array(),
				'exclude' => ''
			),
			'sort' => array(
				'default' => 'makeModel',
				'data' => array()
			),
			'banners' => array(),
			'scripts' => array(
				'data' => array(),
				'inject' => array('detail'=>'','list'=>'')
			),
			'styles' => array(
				'data' => array(),
				'inject' => ''
			),
			'keywords' => array( 'enable'=>'','add'=>'', 'exclude'=>'', 'pot'=>'' ),
			'social' => array(
				'facebook' => array(
					'enable' => ''

				),
				'twitter' => array(
					'enable' => ''
				)
			),
			'color_mapping' => array(
				'enable' => '',
				'exterior' => array(
					'red' => 'red, ruby',
					'blue' => 'blue',
					'yellow' => 'yellow',
					'green' => 'green',
					'orange' => 'orange',
					'tan' => 'tan, brown, granite',
					'gray' => 'gray',
					'silver' => 'silver',
					'black' => 'black, onyx, graphite',
					'white' => 'white, pearl',
				),
				'default_text' => 'Unknown'
			)
		),
		'alt_settings' => array(
			'discourage_seo_visibility' => '',
			'debug_plugin_info' => '',
			'prefer_id' => 0,
			'domain_access_control' => ''
		),
		'database' => array(
			'inventory' => '5.3.2002.01',
			'company' => '5.4.2007.04'
		)
	);

	public static $plugin_information = array();
	public $parameters = array();
	public $taxonomy = null;
	public $vms;
	public $company;
	public $seo_headers;
	public $plugin_slug = '';
	public $page_url = '';
	public static $db_caller;
	public static $multi_request;
	public static $db_company;
	public static $db_active = FALSE;

	function __construct() {
		$this->plugin_slug = plugin_basename(__FILE__);
		$this->execute();
	}

	function execute() {
		$this->load_plugin_information();
		$this->init_wp_cron_job_create();

		$this->load_options();
		$this->set_variables();
		$this->update_options_value();

		$this->cdp_post_handler();
		$this->inventory_import_handler();
		$this->company_update_handler();

		$this->send_additional_header_data();
		$this->load_widgets();
		$this->load_admin();
		$this->setup_routing();
		$this->register_front_ajax();
		$this->add_filter_hooks();
		$this->add_menu_link();
		$this->add_shortcode();
		$this->wp_header_add();
		$this->queue_templates();
	}

	/*
		//// LOAD PLUGIN INFOFORMATION
	*/
	function load_plugin_information() {

				$data = array();

		$file_headers = array (
			'Name' => 'Plugin Name',
			'PluginURI' => 'Plugin URI',
			'Version' => 'Version',
			'Description' => 'Description',
			'Author' => 'Author',
			'AuthorURI' => 'Author URI'
		);

		$data = get_file_data( $this->get_master_file() , $file_headers , 'plugin' );

		$plugin_file = pathinfo( $this->get_master_file() );
		$data[ 'PluginURL' ] = plugins_url( '' , $this->get_master_file() );
		$data[ 'PluginBaseName' ] = $this->get_plugin_basename();
		$data[ 'PluginDir' ] = dirname( __FILE__ );
		self::$plugin_information = $data;
	}

	private function get_master_file() {
		return dirname( __FILE__ ) . '/cardealerpress.php';
	}

	private function get_plugin_basename() {
		return plugin_basename( $this->get_master_file() );
	}

	/*
		//// LOAD OPTIONS
	*/
	function load_options() {
		$loaded_options = get_option( 'cardealerpress_settings' ) ;
		if( !$loaded_options ) {
			update_option( 'cardealerpress_settings' , $this->options );
		} else {
			if( $this->validate_options( $loaded_options , $this->options ) ) {
				update_option( 'cardealerpress_settings' , $loaded_options );
			}
			foreach( $loaded_options as $option_group => $option_values ) {
				$this->options[ $option_group ] = $option_values;
			}
		}
	}

	function validate_options( &$options , &$defaults , &$modified = false ) {
		foreach( $defaults as $key => $value ) {
			if( is_array( $value ) ) {
				$this->validate_options( $options[ $key ] , $value , $modified );
			} elseif( !isset( $options[ $key ] ) || $options[ $key ] == NULL ) {
				$options[ $key ] = $defaults[ $key ];
				$modified = true;
			}
		}

		return $modified;
	}

	function update_options_value(){
		$updates = array('cdpOptionUpdate','dealerChange','dealerChangeClear');
		if( isset($_POST['cdp_Admin_post_action']) && in_array($_POST['cdp_Admin_post_action'],$updates) ){
			if( isset($_POST['cdp_Admin_post_key']) && !empty($_POST['cdp_Admin_post_key']) ){
				$data = array('value'=> $_POST['cdp_Admin_post_new_value'],'key'=>$_POST['cdp_Admin_post_key']);
				self::$db_caller->cdp_data_db_update($data);
			} else {
				$path = (isset($_POST['cdp_Admin_post_path_value'])? $_POST['cdp_Admin_post_path_value']: '');
				$value = (isset($_POST['cdp_Admin_post_new_value'])? $_POST['cdp_Admin_post_new_value']: '');
				if( empty($path) ){
					return null;
				} else {
						$segments = is_array($path) ? $path : explode('/', $path);
						$cur =& $this->options;
						foreach ($segments as $segment) {
						if( strpos($segment, '[]') ){
							$segmentR = str_replace('[]','',$segment);
							$cur =& $cur[$segmentR][];
						} else {
									if (!isset($cur[$segment]))
											$cur[$segment] = array();
									$cur =& $cur[$segment];
						}

						}
					$cur = $value;
					$this->save_new_options();
				}
			}
		}
	}

	function save_new_options() {
		update_option( 'cardealerpress_settings' , $this->options );
		$this->load_options();
	}



	/*
		//// Send Headers
	*/
	function send_additional_header_data(){
		add_action( 'send_headers', array($this, 'additional_headers') );
	}

	function additional_headers() {
		if( !is_admin() ){
			global $wp_version;
			header( 'X-WP-Version: '.$wp_version );
			header( 'X-CDP-Version: '.self::$plugin_information['Version'] );
			if( isset($this->options['vehicle_management_system']['company_information']['id']) ){
				header( 'X-CDP-Company-ID: '.$this->options['vehicle_management_system']['company_information']['id'] );
			}
			if( isset($this->options['vehicle_management_system']['theme']['name']) ){
				header( 'X-CDP-Theme-Name: '.$this->options['vehicle_management_system']['theme']['name'] );
			}
		}
	}

	/*
		//// SET VARIABLES
	*/
	function set_variables(){
		$this->blog = get_current_blog_id();
		self::$db_caller = new cdp_database();
		self::$multi_request = new cdp_multi_request();

		if( empty($this->options[ 'vehicle_management_system' ][ 'company_information' ][ 'id' ]) ){
			add_action( 'admin_notices', array($this, 'display_admin_register_notice') );
		} else {

			self::$db_company = self::$db_caller->cdp_company_request();

			if( $this->options[ 'vehicle_management_system' ][ 'host' ] && $this->options[ 'vehicle_management_system' ][ 'company_information' ][ 'id' ] ){
				$this->vms = new vehicle_management_system(
					$this->options[ 'vehicle_management_system' ][ 'host' ],
					$this->options[ 'vehicle_management_system' ][ 'company_information' ][ 'id' ]
				);
			}

			if( !empty($this->vms) ){
				if( self::$db_company ){
					foreach(self::$db_company as $key=>$values){
						if( $values['company_id'] == $this->options['vehicle_management_system']['company_information' ]['id'] && $values['dealer_id'] == $this->options['vehicle_management_system']['company_information' ]['id'] ){
							$this->company = new \stdClass();
							$this->company->{'id'} = $values['company_id'];
							$this->company->{'name'} = $values['name'];
							$this->company->{'street'} = $values['street'];
							$this->company->{'city'} = $values['city'];
							$this->company->{'state'} = $values['state'];
							$this->company->{'zip'} = $values['zip'];
							$this->company->{'phone'} = $values['phone'];
							$this->company->{'fax'} = '';
							$this->company->{'country_code'} = $values['country'];
							$this->company->{'created'} = $values['created'];
							$this->company->{'updated'} = $values['last_updated'];
							$this->company->{'automall_ids'} = $values['automalls'];
							$this->company->{'domain_name'} = '';
							$this->company->{'seo'} = (object) array('city'=>$values['city'],'state'=>$values['state']);
						}
					}
				} else {
					$this->company = $this->vms->get_company_information()->please();
				}
			}

			if( !empty($this->vms) && !empty($this->company) ){
				$this->seo_headers = new dynamic_site_headers(
					$this->options[ 'vehicle_management_system' ][ 'host' ],
					$this->options[ 'vehicle_management_system' ][ 'company_information' ][ 'id' ],
					$this->options[ 'alt_settings' ][ 'discourage_seo_visibility' ]
				);
			}

		}
	}

	function display_admin_register_notice(){
		$notice = '<div class="error" style="display: block;">CarDealerPress requires a Company ID prior to use. <div style="display: inline-block; border: 1px solid #ababab; padding: 1px; background-color: #fcf9f9;"> <a style="font-weight:bold; font-size: 120%;" target="_blank" href="https://cardealerpress.com/request-cardealerpress-demo-account/"> Request a Demo ID</a> </div> , <div style="display: inline-block; border: 1px solid #ababab; padding: 1px; background-color: #fcf9f9;"> <a style="font-weight:bold; font-size: 120%;" target="_blank" href="https://cardealerpress.com">Purchase Subscription</a></div> or <div style="display: inline-block; border: 1px solid #ababab; padding: 1px; background-color: #fcf9f9;"><a style="font-weight:bold; font-size: 120%;" href="'.get_admin_url().'admin.php?page=cardealerpress_admin">Add</a></div> your Company ID.</div>';
		echo $notice;
	}

	/*
		//// LOAD WIDGETS
	*/
	function load_widgets() {
		if( $this->options[ 'vehicle_management_system' ][ 'host' ] && $this->options[ 'vehicle_management_system' ][ 'company_information' ][ 'id' ] ) {
			add_action( 'widgets_init' , function() { return register_widget( "vms_search_box_widget" ); }  );
		}
	}

	/*
		//// LOAD ADMIN
	*/
	function load_admin() {
		if( is_admin() ){
			include( dirname( __FILE__ ) . '/application/views/options/page.php' );
			$this->admin = new cdp_admin($this->options, $this->company, $this->vms, self::$plugin_information['PluginDir'], self::$plugin_information['Version'] );
		}
	}

	/*
		//// SETUP ROUTING
	*/
	function setup_routing() {
		add_action( 'rewrite_rules_array' , array( &$this , 'add_rewrite_rules' ) , 1 );
		add_action( 'init' , array( &$this , 'create_taxonomies' ) );
	}

	function add_rewrite_rules( $existing_rules ) {
		$new_rules = array();
		if( $this->options[ 'vehicle_management_system' ][ 'host' ] && $this->options[ 'vehicle_management_system' ][ 'company_information' ][ 'id' ] ) {
			$new_rules[ '^(inventory)' ] = 'index.php?taxonomy=inventory';
			$new_rules[ '^(new-vehicle-sitemap\.xml$)' ] = 'index.php?taxonomy=new-vehicle-sitemap';
			$new_rules[ '^(used-vehicle-sitemap\.xml$)' ] = 'index.php?taxonomy=used-vehicle-sitemap';
			$new_rules[ '^(video-vehicle-sitemap\.xml$)' ] = 'index.php?taxonomy=video-vehicle-sitemap';
		}

		return $new_rules + $existing_rules;
	}

	function create_taxonomies() {
		if( $this->options[ 'vehicle_management_system' ][ 'host' ] && $this->options[ 'vehicle_management_system' ][ 'company_information' ][ 'id' ] ) {
			add_filter( 'widget_text' , 'do_shortcode' );
			register_sidebar(array(
				'name' => 'Inventory Vehicle Detail Page',
				'id' => 'vehicle-detail-page',
				'description' => 'Widgets in this area will show up on the Vehicle Detail Page.',
				'before_title' => '<h1>',
				'after_title' => '</h1>',
				'before_widget' => '<div id="%1$s" class="inventory widget %2$s">',
				'after_widget' => '</div>'
			));
			register_sidebar(array(
				'name' => 'Inventory Vehicle List Page',
				'id' => 'vehicle-listing-page',
				'description' => 'Widgets in this area will show up on the Vehicle List Page.',
				'before_title' => '<h1>',
				'after_title' => '</h1>',
				'before_widget' => '<div id="%1$s" class="inventory-list widget %2$s">',
				'after_widget' => '</div>'
			));
			$labels = array(
				'name' => _x( 'Inventory' , 'taxonomy general name' )
			);
			register_taxonomy(
				'inventory',
				array( 'page' ),
				array(
					'hierarchical' => false,
					'labels' => $labels,
					'show_ui' => false,
					'query_var' => true,
					'rewrite' => array( 'slug' => 'inventory' ),
					'show_in_nav_menus' => false,
					'show_tagcloud' => false
				)
			);

			$saleclass = $this->options[ 'vehicle_management_system' ][ 'saleclass' ];
			if( $saleclass == 'all' || $saleclass == 'new' ){
				$labels = array(
					'name' => _x( 'New Inventory Sitemap' , 'taxonomy general name' )
				);
				register_taxonomy(
					'new-vehicle-sitemap',
					array( 'page' ),
					array(
						'hierarchical' => false,
						'labels' => $labels,
						'show_ui' => false,
						'query_var' => true,
						'rewrite' => array( 'slug' => 'new-vehicle-sitemap' ),
						'show_in_nav_menus' => false,
						'show_tagcloud' => false
					)
				);
			}

			if( $saleclass == 'all' || $saleclass == 'used' || $saleclass == 'certified' ){
				$labels = array(
					'name' => _x( 'Used Inventory Sitemap' , 'taxonomy general name' )
				);
				register_taxonomy(
					'used-vehicle-sitemap',
					array( 'page' ),
					array(
						'hierarchical' => false,
						'labels' => $labels,
						'show_ui' => false,
						'query_var' => true,
						'rewrite' => array( 'slug' => 'used-vehicle-sitemap' ),
						'show_in_nav_menus' => false,
						'show_tagcloud' => false
					)
				);
			}

			$videoCheck = self::$db_caller->cdp_inventory_video_check();
			if( $videoCheck[0]['Total'] <> 0 ){
				$labels = array(
					'name' => _x( 'Video Inventory Sitemap' , 'taxonomy general name' )
				);
				register_taxonomy(
					'video-vehicle-sitemap',
					array( 'page' ),
					array(
						'hierarchical' => false,
						'labels' => $labels,
						'show_ui' => false,
						'query_var' => true,
						'rewrite' => array( 'slug' => 'video-vehicle-sitemap' ),
						'show_in_nav_menus' => false,
						'show_tagcloud' => false
					)
				);
			}
		}
	}

	function queue_templates() {
		add_action( 'template_redirect' , array( &$this , 'show_theme' ) , 100 );
	}

	function show_theme() {
		global $wp_query;
		if( $this->options[ 'alt_settings' ][ 'debug_plugin_info' ] ){ $this->log_error_page(); }
		$this->taxonomy = ( isset( $wp_query->query_vars[ 'taxonomy' ] ) ) ? $wp_query->query_vars[ 'taxonomy' ] : NULL;
		if( $this->vms ){
			switch( $this->taxonomy ) {
				case 'inventory':
					if( $this->options[ 'vehicle_management_system' ][ 'host' ] ) {

						$this->parameters = $this->get_parameters();
						$this->fix_bad_wordpress_assumption();

						$current_theme = apply_filters('cdp_theme_name', $this->options['vehicle_management_system']['theme']['name']);
						$theme_path = dirname( __FILE__ ) . '/application/views/inventory/' . $current_theme;
						$theme_path = apply_filters('cdp_theme_path', $theme_path);

						if( $this->autocheck_flag ){
							include_once( dirname( __FILE__ ) . '/application/views/inventory/autocheck.php' );
						} else if( $this->print_page ){
							$file = dirname( __FILE__ ) . '/application/views/inventory/print.php';
							$file = apply_filters('cdp_print', $file);
							include_once( $file );
						} else if( $this->saved_vehicles ){
							$file = dirname( __FILE__ ) . '/application/views/inventory/saved.php';
							include_once( $file );
						} else if( $this->compare_vehicles ){
							$file = dirname( __FILE__ ) . '/application/views/inventory/compare.php';
							include_once( $file );
						} else {
							if( isset($this->parameters['vin']) ){
								add_action('wp_head', array($this, 'cdp_add_canonical_link'));
							}

							if( $handle = opendir( dirname( __FILE__ ) . '/application/views/inventory' ) ) {
								while( false != ( $file = readdir( $handle ) ) ) {
									if( strtolower($current_theme) == 'flamingo' || self::$db_active ){
										if( $file == 'invdb_index.php' ) {
											include_once( dirname( __FILE__ ) . '/application/views/inventory/invdb_index.php' );
										}
									} else {
										if( $file == 'inv_index.php' ) {
											include_once( dirname( __FILE__ ) . '/application/views/inventory/inv_index.php' );
										}
									}

								}
								closedir( $handle );
							} else {
								echo __FUNCTION__ . ' Could not open directory at: ' . $theme_path;
								return false;
							}
						}

						$this->stop_wordpress();
					}
				break;
				case 'new-vehicle-sitemap':
				case 'used-vehicle-sitemap':
				case 'video-vehicle-sitemap':
				$this->parameters = $this->get_parameters();
				$seo_hack = array( 'city' => $this->company->seo->city , 'state' => $this->company->seo->state , 'country_code' => $this->company->country_code );
				$this->seo_headers->apply_headers( $this->parameters, $seo_hack );
				if ( !empty($this->seo_headers->headers) ){

					$company_id = $this->options[ 'vehicle_management_system' ][ 'company_information' ][ 'id' ];

					$sitemap_request = 'https://api.dealertrend.com/api/companies/' . $company_id . '/vehicles.json';
					$sitemap_handler = new http_request( $sitemap_request , 'vehicle_sitemap' );

					$theme_path = dirname( __FILE__ ) . '/application/views/sitemap';

					if( $handle = opendir( $theme_path ) ) {
						while( false != ( $file = readdir( $handle ) ) ) {
							if( $file == 'index.php' ) {
								include_once( $theme_path . '/index.php' );
							}
						}
						closedir( $handle );
					} else {
						echo __FUNCTION__ . ' Could not open directory at: ' . $theme_path;
						return false;
					}
					$this->stop_wordpress();

				} else {
					echo 'Page not Available. Confirm SEO Helpers is activated.';
					$this->stop_wordpress();
				}

				break;
			}
		}
		// Handle Gravity Form Pop-up

		if( isset($wp_query->query['name']) && $wp_query->query['name'] === 'cdp-form-display' && isset($_GET['form_id']) ){
			include_once( dirname( __FILE__ ) . '/application/views/form-popup.php' );
			$this->stop_wordpress();
		}
	}

	function cdp_add_canonical_link(){
		$rules = get_option( 'rewrite_rules' ); $url_rule = ( isset($rules['^(inventory)']) ) ? TRUE : FALSE;
		$link_params = array( 'year' => $this->parameters['year'], 'make' => $this->parameters['make'],  'model' => $this->parameters['model'], 'state' => $this->company->state, 'city' => $this->company->city, 'vin' => $this->parameters['vin'] );
		$canonicalLink = generate_inventory_link($url_rule,$link_params,'','',1);

		echo '<link href="'.site_url().$canonicalLink.'" rel="canonical" />';
	}

	function register_front_ajax(){
		require_once( dirname( __FILE__ ) . '/application/functions/fn_front_ajax.php' );
		$front_ajax = new cdp_front_ajax($this->options,$this->vms,$this->company);
		add_action('wp_ajax_cdp_front_ajax_request', array(&$front_ajax, 'cdp_front_handle_request') );
		add_action('wp_ajax_nopriv_cdp_front_ajax_request', array(&$front_ajax, 'cdp_front_handle_request') );
	}

	function load_vms_error(){
		get_header();
		$this->display_admin_register_notice();
		get_footer();
	}

	function log_error_page(){
		if( function_exists('http_response_code') ){
			$page_response = http_response_code();
			if( $page_response !== 200 ){
				$page = 'http'.(isset($_SERVER['HTTPS']) ? 's' : '').'://'."$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
				$referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER']: '';
				$error_message = 'Response Code: '.$page_response.' | Page URL: '.$page.(!empty($referer) ? ' | Referer: '.$referer : '');
				error_log('CDP Response Code Error Message ('.self::$plugin_information['Version'].') - ');error_log($error_message);
			}
		}
	}

	function stop_wordpress() {
		exit;
	}

	function fix_bad_wordpress_assumption() {
		global $wp_query;
		$wp_query->is_home = false;
	}

	function get_parameters() {
		global $wp;
		global $wp_rewrite;

		$permalink_parameters = !empty( $wp_rewrite->permalink_structure ) ? explode( '/' , $wp->request ) : array();
		$server_parameters = isset( $_GET ) ? array_map( array( &$this , 'sanitize_inputs' ) , $_GET ) : NULL;
		if( isset($server_parameters['trim']) ){
			$server_parameters['trim'] = ( isset($_GET['trim'])? $_GET['trim']: '');
		}
		$parameters = array();
		$this->compare_vehicles = $this->saved_vehicles = $this->print_page = $this->autocheck_flag = false;

		switch( $this->taxonomy ) {
			case 'inventory';
				$server_parameters[ 'per_page' ] = $this->options[ 'vehicle_management_system' ][ 'theme' ][ 'per_page' ];

				switch( $this->options[ 'vehicle_management_system' ][ 'saleclass' ] ) {
					case 'new':
						$server_parameters[ 'saleclass' ] = 'New';
						break;
					case 'used':
						$server_parameters[ 'saleclass' ] = 'Used';
						break;
					case 'certified':
						$server_parameters[ 'saleclass' ] = 'Used';
						$server_parameters[ 'certified' ] = 'yes';
						break;
				}

				if( isset( $permalink_parameters[1] ) && $permalink_parameters[1] == 'autocheck' ){
					$this->autocheck_flag = true;
					$this->autocheck_vin = ( isset($permalink_parameters[2]) ) ? $permalink_parameters[2] : 0;
				} else if( isset( $permalink_parameters[1] ) && $permalink_parameters[1] == 'saved-vehicles' ){
					$this->saved_vehicles = true;
				} else if( isset( $permalink_parameters[1] ) && $permalink_parameters[1] == 'compare-vehicles' ){
					$this->compare_vehicles = true;
				} else {
					foreach( $permalink_parameters as $key => $value ) {
						switch( $key ) {
							case 0: $index = 'taxonomy'; break;
							case 1:
								if( is_numeric( $value ) ) {
									$index = 'year';
								} else {
									$index = 'saleclass';
								}
							break;
							case 2: $index = 'make'; break;
							case 3: $index = 'model'; break;
							case 4: $index = 'state'; break;
							case 5: $index = 'city'; break;
							case 6: $index = 'vin'; break;
							default: return; break;
						}
						$parameters[ $index ] = $value;
					}
					if( isset( $server_parameters['print_page'] ) ){
						$this->print_page = true;
					}
				}
			break;
		}
		return array_merge( $parameters , $server_parameters );
	}

	static function flush_rewrite_rules( $override = false ) {
		if( $override === false ) {
			$pagenow = $_SERVER['SCRIPT_NAME'];
			if ( is_admin() && isset($_GET['activate'] ) && ( $pagenow == "/wp-admin/plugins.php" || $pagenow == "/wp-admin/network/plugins.php" ) ) {
				global $wp_rewrite;
				return $wp_rewrite->flush_rules();
			}
		} else {
				global $wp_rewrite;
				return $wp_rewrite->flush_rules();
		}
	}

	function sanitize_inputs( $input ) {
		if( is_array( $input ) ) {
			foreach( $input as $key => $value ) {
				$input[ $key ] = is_scalar( $value ) ? wp_kses_data( $value , false , 'http' ) : array_map( array( &$this , 'sanitize_inputs' ) , $value );
			}
		} else {
			$input = wp_kses_data( $input , false , 'http' );
		}

		return $input;
	}

	static function get_themes( $type ) {
		$directories = scandir( dirname( __FILE__ ) . '/application/views/' . $type . '/' );
		$ignore = array( '.' , '..' );
		$exclude = array( 'php' );
		foreach( $directories as $key => $value ) {
			$ext = pathinfo($value, PATHINFO_EXTENSION);
			if( in_array( $ext, $exclude ) ){
				unset( $directories[ $key ] );
			}
			if( in_array( $value , $ignore ) ){
				unset( $directories[ $key ] );
			}
		}

		return array_values( $directories );
	}

	function add_filter_hooks() {
		/**
		 * Filter to add custom link to index sitemap for wpseo by yoast
		 **/
		add_filter( 'wpseo_sitemap_index', array( &$this, 'add_custom_sitemap_link' ) );
		add_filter( 'redirect_canonical', array( &$this, 'stop_canonical' ) );
		add_filter( 'gform_pre_send_email', function($email){
			if( isset($_COOKIE['cdp_page_url']) ){
				$merge_tag = '{cdp_embed_url}';
				$new_message = str_replace($merge_tag, $_COOKIE['cdp_page_url'],$email['message']);
				$email['message'] = $new_message;
				return $email;
			} else {
				return $email;
			}
		});
		if( isset($_GET['external_user_id']) ){
			add_filter("gform_field_value_dt_external_user_id", function(){ return $_GET['external_user_id']; });
			setcookie('cdp_external_user_id',$_GET['external_user_id'], 0, '/' );
		}
		// Removes extra elements being added to widgets
		remove_filter('widget_text_content', 'wpautop');

		add_filter( 'gform_notification', array($this,'cdp_change_notification_format'), 10, 3 );
	}

	function add_custom_sitemap_link () {
		/**
		 * Filter to add custom link to index sitemap for wpseo by yoast
		 *
		 * @return string $custom_link
		 **/
		//$date_raw = date("Y-m-d H:i P", strtotime('-1 day', strtotime( date("Y-m-d H:i P", current_time( 'timestamp', 0 ))) ) );
		$this->parameters = $this->get_parameters();
		$seo_hack = array( 'city' => $this->company->seo->city , 'state' => $this->company->seo->state , 'country_code' => $this->company->country_code );
		$this->seo_headers->apply_headers( $this->parameters, $seo_hack );
		if( !empty($this->seo_headers->headers) ){
			$date_raw = date("Y-m-d H:i P", current_time( 'timestamp', 0 ));
			$utc_timezone = new \DateTimeZone( 'UTC' );
			$datetime = new \DateTime( $date_raw, $utc_timezone );
			$last_mod = $datetime->format('c');

			$saleclass = $this->options[ 'vehicle_management_system' ][ 'saleclass' ];

			$custom_link = '';
			if( $saleclass == 'all' || $saleclass == 'new' ){
				$custom_link .= '<sitemap>' . "\n";
				$custom_link .= '<loc>' . home_url('new-vehicle-sitemap.xml') . '</loc>' . "\n";
				$custom_link .= '<lastmod>' . htmlspecialchars($last_mod) . '</lastmod>' . "\n";
				$custom_link .= '</sitemap>' . "\n";
			}

			if( $saleclass == 'all' || $saleclass == 'used' || $saleclass == 'certified' ){
				$custom_link .= '<sitemap>' . "\n";
				$custom_link .= '<loc>' . home_url('used-vehicle-sitemap.xml') . '</loc>' . "\n";
				$custom_link .= '<lastmod>' . htmlspecialchars($last_mod) . '</lastmod>' . "\n";
				$custom_link .= '</sitemap>' . "\n";
			}

			$videoCheck = self::$db_caller->cdp_inventory_video_check();
			if( $videoCheck[0]['Total'] <> 0 ){
				$custom_link .= '<sitemap>' . "\n";
				$custom_link .= '<loc>' . home_url('video-vehicle-sitemap.xml') . '</loc>' . "\n";
				$custom_link .= '<lastmod>' . htmlspecialchars($last_mod) . '</lastmod>' . "\n";
				$custom_link .= '</sitemap>' . "\n";
			}

			return $custom_link;
		}
	}

	function stop_canonical( $redirect ) {
		$sitemap = get_query_var( 'taxonomy' );
		if ( !empty( $sitemap ) && ( $sitemap == 'new-vehicle-sitemap' || $sitemap == 'used-vehicle-sitemap' || $sitemap == 'video-vehicle-sitemap' ) ){
			return false;
		}
		return $redirect;
	}

	function add_menu_link() {
		// Adds a link to the admin bar for VMS
		add_action( 'wp_before_admin_bar_render', array( $this, "add_vms_link" ) );
	}

	function add_vms_link() {
		global $wp_admin_bar;
		if ( !is_super_admin() || !is_admin_bar_showing() )
			return;

		$wp_admin_bar->add_menu( array(
			'id'   => 'vms_link',
			'meta' => array( 'target' => '_blank'),
			'title' => 'Manage Inventory',
			'href' => 'https://manager.dealertrend.com'
			)
		);
	}

	function add_shortcode() {
		$sc_run = new sc_run( $this->vms, $this->company, $this->options, self::$plugin_information[ 'PluginURL' ] );
		add_shortcode( 'inventory_list', array( $sc_run, 'inventory_list' ) );
		add_shortcode( 'inventory_detail', array( $sc_run, 'inventory_detail' ) );
		add_shortcode( 'inventory_slider', array( $sc_run, 'inventory_slider' ) );
		add_shortcode( 'inventory_counter', array( $sc_run, 'inventory_counter' ) );
		add_shortcode( 'inventory_search', array( $sc_run, 'inventory_search' ) );
	}

	function wp_header_add(){
		add_action('wp_head', array($this, 'add_meta_viewport') );
	}

	function add_meta_viewport(){
		echo '<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0">';
	}

	function save_options() {
		update_option( 'cardealerpress_settings' , $this->options );
		$this->load_options();
	}

	function cdp_action_init_inventory_call(){
		self::$multi_request->init_inventory_call();
	}

	function cdp_action_init_inventory_call_manual(){
		self::$multi_request->init_inventory_call_manual();
	}

	function cdp_action_init_dealer_refresh(){
		self::$multi_request->init_dealer_refresh();
	}

	function cdp_action_init_inventory_clear(){
		self::$multi_request->init_inventory_clear();
	}

	function cdp_action_update_inventory_color(){
		self::$multi_request->init_inventory_color_update();
	}

	function cdp_post_handler(){
		/*******
			Cron Requests
		*******/
		if( isset($_POST['cdp_Admin_post_action']) && $_POST['cdp_Admin_post_action'] == 'addCDPCronJob'){
			$this->cardealerpress_activation();
				}
		## dont remember why this was added.... not sure its relevant anymore.....
		if( isset($_POST['cdp_Admin_post_action']) && $_POST['cdp_Admin_post_action'] == 'deleteCDPCronJob'){
			$this->remove_cron_schedule();
		}


		if( isset($_POST['cdp_Admin_post_action']) && $_POST['cdp_Admin_post_action'] == 'clearTransient'){
			delete_transient('cdp_manual_update_handler_processing_'.$this->blog);
			delete_transient('cdp_auto_update_handler_processing_'.$this->blog);
		}
		if( isset($_POST['cdp_Admin_post_action']) && $_POST['cdp_Admin_post_action'] == 'resetInventory'){
			self::$multi_request->init_inventory_clear();
		}

		if( isset($_POST['cdp_Admin_post_action']) && $_POST['cdp_Admin_post_action'] == 'dealerRefresh'){
			self::$multi_request->init_company_handler();
		}
		if( isset($_POST['cdp_Admin_post_action']) && $_POST['cdp_Admin_post_action'] == 'dealerAdd'){
			if( isset($_POST['cdp_Admin_post_new_value']) && !empty($_POST['cdp_Admin_post_new_value']) ){
				// Adds Dealer to CDP Data table
				self::$multi_request->insert_dealer_data_handler($_POST['cdp_Admin_post_new_value']);
				// Run Company handler to add and populate inventory for new dealer
				self::$multi_request->init_company_handler();
			}

		}
		if( isset($_POST['cdp_Admin_post_action']) && $_POST['cdp_Admin_post_action'] == 'dealerDelete'){
			if( isset($_POST['cdp_Admin_post_new_value']) && !empty($_POST['cdp_Admin_post_new_value']) ){
				// Remove Dealer from CDP Data, Companies and Inventory table
				self::$multi_request->remove_dealer_data_handler($_POST['cdp_Admin_post_new_value']);
			}
		}
		if( isset($_POST['cdp_Admin_post_action']) && $_POST['cdp_Admin_post_action'] == 'dealerChange'){
			if( isset($_POST['cdp_Admin_post_new_value']) && isset($_POST['cdp_Admin_post_previous_id']) && !empty($_POST['cdp_Admin_post_new_value']) ){
				// Remove Dealer from CDP Data, Companies and Inventory table
				self::$multi_request->remove_dealer_data_handler($_POST['cdp_Admin_post_previous_id'],$_POST['cdp_Admin_post_new_value']);
				// Adds Dealer to CDP Data table
				self::$multi_request->insert_dealer_data_handler($_POST['cdp_Admin_post_new_value']);
				// Run Company handler to add and populate inventory for new dealer
				self::$multi_request->init_company_handler();

			}
		}
		if( isset($_POST['cdp_Admin_post_action']) && $_POST['cdp_Admin_post_action'] == 'dealerChangeClear'){
			if( isset($_POST['cdp_Admin_post_new_value']) && !empty($_POST['cdp_Admin_post_new_value']) ){
				// Remove Dealer from CDP Data, Companies and Inventory table
				self::$multi_request->remove_dealer_data_clear_handler();
				// Adds Dealer to CDP Data table
				self::$multi_request->insert_dealer_data_handler($_POST['cdp_Admin_post_new_value']);
				// Run Company handler to add and populate inventory for new dealer
				self::$multi_request->init_company_handler();
			}
		}
	}

	function inventory_import_handler(){
		// Allows for Manual Imports to bypass Auto Import Check
		if( isset($_POST['cdp_Admin_post_action']) && (isset($_POST['cdp_Admin_post_data']) && !empty($_POST['cdp_Admin_post_data'])) && !get_transient('cdp_manual_update_handler_processing') ){
			error_log('Manuel Import - '.$_POST['cdp_Admin_post_action'].' | Dealer - '.$_POST['cdp_Admin_post_data']);
			set_transient('cdp_manual_update_handler_processing_'.$this->blog, 'Running', 60 );
			if( $_POST['cdp_Admin_post_action'] == 'fullImport' ){
				// Full Import
				self::$multi_request->init_inventory_handler(0);
			} else if( $_POST['cdp_Admin_post_action'] == 'dealerImport' ){
				// Dealer Import
				self::$multi_request->init_inventory_handler($_POST['cdp_Admin_post_data'],TRUE);
			}
			delete_transient('cdp_manual_update_handler_processing_'.$this->blog);
		}
	}

	function company_update_handler(){
		// Auto update Company data every 4 hours if needed
		if( !get_transient('cdp_company_auto_update_handler_processing_'.$this->blog) ){
			error_log('Auto Company Update Process');
			set_transient('cdp_company_auto_update_handler_processing_'.$this->blog, 'Running', 60 * 60 * 4 );
			self::$multi_request->init_company_handler();
		}
	}

	function init_wp_cron_job_create(){
		register_activation_hook(__FILE__, array($this,'cardealerpress_activation') );
		add_action( 'cdp_cron_inventory_update', array($this, 'init_cdp_cron_inventory_update'));
		$this->add_wp_cron_job();
	}

	function cardealerpress_activation(){
		error_log('CDP Activation Check');
		$this->add_wp_cron_job();
	}

	function add_wp_cron_job(){
		if ( ! wp_next_scheduled( 'cdp_cron_inventory_update' ) ) {
			error_log('CDP Cron Job Created');
			wp_schedule_event( time(), 'hourly', 'cdp_cron_inventory_update' );
		}
	}
	function init_cdp_cron_inventory_update(){
		error_log('CDP Inventory Cron Update running');
		self::$multi_request->init_inventory_auto_update_handler();
	}

	function cdp_change_notification_format($notification, $form, $entry){
		if ( $notification['name'] == 'Admin Notification - ADF' || $notification['name'] == 'Admin Notification ADF' ) {
			// change notification format to text from the default html
			$notification['message_format'] = 'text';
			return $notification;
		} else {
			$notification['message_format'] = 'html';
			return $notification;
		}
	}

	function remove_cron_schedule(){
		error_log('CDP WP Cron cdp_cron_inventory_update removed');
		$timestamp = wp_next_scheduled( 'cdp_cron_inventory_update' );
		wp_unschedule_event( $timestamp, 'cdp_cron_inventory_update' );
	}

}

?>
